package com.adc.da.bs.cvt.validate.constant;

public enum  ValidateConstant {

    E1SORT1(1,"电动汽车用锌空气电池", "GB/T18333.2-2015"),
    E1SORT2(2,"车用超级电容器","QC/T741-2014"),
    E1SORT3(3,"电动汽车用动力蓄电池循环寿命要求及试验方法","GB/T31484-2015"),
    E1SORT4(4,"电动汽车用动力蓄电池安全要求及试验方法","GB/T31485-2015"),
    E1SORT5(5,"电动汽车用动力蓄电池电性能要求及试验方法","GB/T31486-2015"),
    E1SORT6(6,"电动汽车用锂离子动力蓄电池包和系统 第3部分：安全性要求与测试方法","GB/T31467.3-2015"),
    E1SORT7(43,"汽车动力蓄电池编码规则","GB/T34014-2017"),
    E1SORT8(46,"热扩散测试规范","装备中心[2019]869号文"),
    E2SORT1(7,"电动汽车用驱动电机系统 第1部分：技术条件","GB/T18488.1-2015"),
    E2SORT2(8,"电动汽车用驱动电机系统第2部分：试验方法","GB/T18488.2-2015"),
    E3SORT1(9,"电动汽车 安全要求 第1部分：车载可充电储能系统（REESS）","GB/T18384.1-2015"),
    E3SORT2(10,"电动汽车 安全要求 第2部分：操作安全和故障防护","GB/T18384.2-2015"),
    E3SORT3(11,"电动汽车 安全要求 第3部分：人员触电防护","GB/T18384.3-2015"),
    EA(12,"燃料电池电动汽车 安全要求","GB/T24549-2009"),
    E4SORT1(13,"电动车辆的电磁场发射强度的限值和测量方法,宽带,9kHz～30MHz","GB/T18387-2008"),
    E4SORT2(40,"电动车辆的电磁场发射强度","GB/T18387-2017"),
    E5SORT1(14,"电动汽车操纵件、指示器及信号装置的标志","GB/T4094.2-2005"),
    E5SORT2(41,"电动汽车操纵件、指示器及信号装置的标志","GB/T4094.2-2017"),
    E6(15,"电动汽车用仪表","GB/T19836-2005"),
    E7SORT1(16,"电动汽车 能量消耗率和续驶里程试验方法","GB/T18386-2005"),
    E7SORT2(42,"电动汽车 能量消耗率和续驶里程","GB/T18386-2017"),
    E7SORT3(17,"轻型混合动力电动汽车能量消耗量试验方法","GB/T19753-2013"),
    E7SORT4(18,"重型混合动力电动汽车能量消耗量试验方法","GB/T19754-2015"),
    E8(19,"电动汽车风窗玻璃除霜除雾系统的性能要求及试验方法","GB/T24552-2009"),
    E9(20,"纯电动乘用车 技术条件","GB/T28382-2012"),
    EB(21,"燃料电池发动机性能试验方法","GB/T24554-2009"),
    EC(22,"燃料电池电动汽车 加氢口","GB/T26779-2011"),
    EDSORT1(23,"燃料电池电动汽车 车载氢系统 技术要求","GB/T26990-2011"),
    EDSORT2(24,"燃料电池电动汽车 车载氢系统 试验方法","GB/T29126-2012"),
    EE(25,"电动汽车传导充电用连接装置 第1部分：通用要求","GB/T20234.1-2015"),
    EF(26,"电动汽车传导充电用连接装置 第2部分：交流充电接口","GB/T20234.2-2015"),
    EG(27,"电动汽车传导充电用连接装置 第3部分：直流充电接口","GB/T20234.3-2015"),
    EH(28,"电动汽车非车载传导式充电机与电池管理系统之间的通信协议","GB/T27930-2015"),
    E28(29,"电动汽车碰撞后安全要求","GB/T31498-2015"),
    EL(30,"超级电容电动城市客车","QC/T838-2010"),
    EM(31,"插电式混合动力电动乘用车 技术条件","GB/T32694-2016"),
    EN(32,"电动汽车远程服务与管理系统技术规范 第2部分：车载终端","GB/T32960.2-2016"),
    EK(33,"电动汽车远程服务与管理系统技术规范 第3部分：通讯协议及数据格式","GB/T32960.3-2016"),
    E0(34,"电动汽车 定型试验规程;混合动力电动汽车 定型试验规程;超级电容电动城市客车 定型试验规程;电动汽车 动力性能 试验方法;混合动力电动汽车 动力性能 试验方法;燃料电池电动汽车 最高车速试验方法","GB/T18388-2005;GB/T19750-2005;QC/T925-2013;GB/T18385-2005;GB/T19752-2005;GB/T26991-2011"),
    EJ(35,"电动客车安全技术条件","工信部装[2016]377号文"),
    EP(36,"动力电池能量密度（PED）","《动力电池、燃料电池相关技术指标测试方法(试行)》"),
    EO(37,"动力电池（含超级电容器）最大充电倍率（CR）","《动力电池、燃料电池相关技术指标测试方法(试行)》"),
    ER(38,"燃料电池系统（发动机）额定功率","《动力电池、燃料电池相关技术指标测试方法(试行)》"),
    ES(39,"燃料电池汽车纯电续驶里程","《动力电池、燃料电池相关技术指标测试方法(试行)》"),
    EU(45,"质子交换膜燃料电池模块","GB/T33978-2017");

    private Integer seq;
    private String jyxm;
    private String jyyj;

    private ValidateConstant(Integer seq, String jyxm, String jyyj){
        this.seq = seq;
        this.jyxm = jyxm;
        this.jyyj = jyyj;
    }

    public Integer getSeq() {
        return seq;
    }

    public void setSeq(Integer seq) {
        this.seq = seq;
    }

    public String getJyxm() {
        return jyxm;
    }

    public void setJyxm(String jyxm) {
        this.jyxm = jyxm;
    }

    public String getJyyj() {
        return jyyj;
    }

    public void setJyyj(String jyyj) {
        this.jyyj = jyyj;
    }
}
