package com.adc.da.bs.login.dao;

import com.adc.da.bs.webservice.entity.DataAndFilesLogs;
import com.adc.da.bs.webservice.tranws.ItransferfilesService;
import com.adc.da.bs.webservice.tranws.Transferfiles;
import com.adc.da.util.utils.StringUtils;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
/*import com.adc.da.enterprise.entity.EncodeRuleBasicEO;
import com.adc.da.enterprise.entity.EnterpriseAppEO;
import com.adc.da.enterprise.entity.EnterpriseEO;*/

/**
 * 推荐目录Dao
 * zhong
 * 2018-3-22
 */


@Component
public class LoginDao{
	protected final EntityManager entityManager;
	@Autowired
	public LoginDao(EntityManager entityManager) {
		super();
        this.entityManager = entityManager;
	}
	/**   
	 * @Title: getresult   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qyid
	 * @param @return    设定文件   
	 * @return String    返回类型   
	 * @author ADC_ZH 
	 * @date 上午10:36:35 
	*/   
	public String getresult(String qyid) {
		String sql = "select RESULT from RETRIEVAL.ret_users where username= ?";
		Query query = entityManager.createNativeQuery(sql.toString());
		query.setParameter(1,qyid);
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		String RESULT=list.get(0).get("RESULT")==null?"N":list.get(0).get("RESULT").toString();
		return RESULT;
	}
	
	public Map<String, Object> findMap(String username) {
		String sql = "select (SELECT LOGINFLAG FROM NERDS.CHECKFLAG WHERE ROWNUM=1) , R.* from RETRIEVAL.ret_users R where R.username= ?";
		Query query = entityManager.createNativeQuery(sql.toString());
		query.setParameter(1,username);
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		if(list.isEmpty()) return new HashMap<String, Object>();
		return list.get(0);
	}
	
	@Transactional
	public void access(Map<String, Object> res) {
		 String insSql = " INSERT INTO NERDS.RETRIEVAL_SYS_LOG (ID,IP,USERID,UP_DATE,CLICKMODULE,NOTE,SESSIONID) VALUES "
		 		+ "(NERDS.RETRIEVAL_SYS_LOG_SEQ.nextval, ?, ?, SYSDATE, ?, ?, ?) ";
	     Query insQuery = entityManager.createNativeQuery(insSql);
	     insQuery.setParameter(1, res.get("ip")==null?"":res.get("ip").toString());
	     insQuery.setParameter(2, res.get("userid")==null?"":res.get("userid").toString());
	     insQuery.setParameter(3, res.get("click")==null?"":res.get("click").toString());
	     insQuery.setParameter(4, res.get("note")==null?"":res.get("note").toString());
	     insQuery.setParameter(5, res.get("sessionId")==null?"":res.get("sessionId").toString());
	     insQuery.executeUpdate();
	}


	@Transactional
	public void updateUserStatus(String username) {
			String insSql = " UPDATE RETRIEVAL.RET_USERS SET RESULT = 'D' WHERE RESULT <>'Y' AND USERNAME= ? ";
			Query insQuery = entityManager.createNativeQuery(insSql);
			insQuery.setParameter(1, username);
			insQuery.executeUpdate();
	}
	@Transactional 
	public void importDpData() {
			String sql = "SELECT * FROM nerds.GGCS_ZBZX_DP where 批次 > '338' and flag is null";
			Query query = entityManager.createNativeQuery(sql.toString());
			query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
			List<Map<String, Object>> list = query.getResultList();
			for(Map<String, Object> rSet : list){
				String insertSql = "insert into  retrieval.chpdpk_zk (DPID,发布日期,企业ID,企业名称,底盘型号,底盘类别,产品名称,产品商标,批次,更改,YSC,M发动机,M发企业,M排量,M功率,前轮距,后轮距,企业地址,注册地址,生产地址,电子信箱,电话号码,传真号码,邮政编码,目录序号,长,宽,高,燃料种类,依据标准,转向形式,轴数,轴距,弹簧片数,轮胎数,轮胎规格,总质量,整备质量,挂车质量,半挂鞍座,前排乘客,接近离去角,前悬后悬,最高车速,识别代号,其它,法人代表,联系人,轴荷,基础,排放水平,PICI,KZ,防抱死系统,GID,产品号,生效日期,CHANG_N,KUAN_N,GAO_N,ZZL_N,EDZL_N,ZBZL_N,YBZP,HBZP,XZZP2,XZZP3,XZZP1,CHFHZP) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
				
				// 参数处理--企业id等信息
				String qyidNew = (String) rSet.get("QY_ID");
				sql = "select * from ggcain06.qyname  where qy_id = ? or adc_qy_id = ? AND zhc_add IS NOT NULL AND mlxh IS NOT NULL AND frdb is not null and address is not null and kt = 'Y' ";
//				List<Map<String, Object>> queryForList = retrievalJdbcTemplate.queryForList(sql,new Object[] { qymc });
				Query query2 = entityManager.createNativeQuery(sql.toString());
				query2.setParameter(1,qyidNew);
				query2.setParameter(2,qyidNew);
				query2.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
				List<Map<String, Object>> queryForList = query2.getResultList();
				
				String qyid = "";
				String address = "";
				String zhc_add = "";
				String email = "";
				String telephone = "";
				String fax = "";
				String postcode = "";
				String mlxh = "";
				String zcxh = "";
				String frdb = "";
				String lxr = "";

				if (queryForList.size() > 0) {
					qyid = (String) queryForList.get(0).get(
							"QY_ID");
					address = (String) queryForList.get(0).get(
							"ADDRESS");
					zhc_add = (String) queryForList.get(0).get(
							"ZHC_ADD");
					email = (String) queryForList.get(0).get(
							"EMAIL");
					telephone = (String) queryForList.get(0)
							.get("TELEPHONE");
					fax = (String) queryForList.get(0).get(
							"FAX");
					postcode = (String) queryForList.get(0)
							.get("POSTCODE");
					mlxh = (String) queryForList.get(0).get(
							"MLXH");
					zcxh = (String) queryForList.get(0).get(
							"ZCXH");
					frdb = (String) queryForList.get(0).get(
							"FRDB");
					lxr = (String) queryForList.get(0).get(
							"LXR");
				}
				//参数处理--发动机型号
				String fdjxh="";
				if(null!=rSet.get("发动机型号")){
					fdjxh = ((String) rSet.get("发动机型号"))
					.replaceAll(";", " ").replaceAll("；",
							" ");	
				}
				//参数处理--排量
				String pl="";
				if(null!=rSet.get("发动机排量")){
					pl = ((String) rSet.get("发动机排量"))
					.replaceAll(";", " ").replaceAll("；",
							" ");	
				}
				//参数处理--发动机功率
				String fdjgl="";
				if(null!=rSet.get("发动机功率")){
					fdjgl = ((String) rSet.get("发动机功率"))
					.replaceAll(";", " ").replaceAll("；",
							" ");	
				}						
				//参数处理--车辆识别代号
				String clsbdh="";
				if(null!=rSet.get("识别代号")){
					clsbdh = ((String) rSet.get("识别代号"))
					.replaceAll(";", " ").replaceAll("；",
							" ");	
				}							
				
				try {
					Query insQuery = entityManager.createNativeQuery(insertSql);
					
					 insQuery.setParameter(1,rSet.get("底盘ID"));
					 //处理发布日期
					 String fbrq = (String) rSet.get("发布日期");
					 if(null!= fbrq && !"".equals(fbrq)){
						 fbrq = fbrq.replace("-", "").replace("&nbsp;", "").replace("</td>", "");
					 }
					 insQuery.setParameter(2,fbrq);
					 insQuery.setParameter(3,qyidNew );
					 insQuery.setParameter(4,rSet.get("企业名称"));
					 insQuery.setParameter(5,rSet.get("底盘型号"));
					 insQuery.setParameter(6,rSet.get("底盘类别"));
					 insQuery.setParameter(7,rSet.get("产品名称"));
					 insQuery.setParameter(8,rSet.get("产品商标"));
					 insQuery.setParameter(9,rSet.get("批次"));
					 insQuery.setParameter(10,"");
					 insQuery.setParameter(11,"");
					 insQuery.setParameter(12,fdjxh);
					 insQuery.setParameter(13,rSet.get("发动机生产企业"));
					 insQuery.setParameter(14,pl);
					 insQuery.setParameter(15,fdjgl);
					 insQuery.setParameter(16,rSet.get("前轮距"));
					 insQuery.setParameter(17,rSet.get("后轮距"));
					 insQuery.setParameter(18,address);
					 insQuery.setParameter(19,zhc_add);
					 insQuery.setParameter(20,rSet.get("生产地址"));
					 insQuery.setParameter(21,email);
					 insQuery.setParameter(22,telephone);
					 insQuery.setParameter(23,fax);
					 insQuery.setParameter(24,postcode);
					 insQuery.setParameter(25,mlxh);
					 insQuery.setParameter(26,rSet.get("外形尺寸长"));
					 insQuery.setParameter(27,rSet.get("外形尺寸宽"));
					 insQuery.setParameter(28,rSet.get("外形尺寸高"));
					 
					 String rlzl = (String) rSet.get("燃料种类");
						if(null!=rlzl && "P".equals(rlzl)){
							rlzl = "氢气";
						}
						if(null!=rlzl && "B".equals(rlzl)){
							rlzl = "柴油";
						}
						if(null!=rlzl && "A".equals(rlzl)){
							rlzl = "汽油";
						}
						if(null!=rlzl && "C".equals(rlzl)){
							rlzl = "纯电动";
						}
						if(null!=rlzl && "E".equals(rlzl)){
							rlzl = "LNG";
						}
					 insQuery.setParameter(29,rlzl);
//					 insQuery.setParameter(29,rSet.get("燃料种类"));
					 insQuery.setParameter(30,rSet.get("依据标准"));
					 
					 String zxxs = (String) rSet.get("转向形式");
						if(null!=zxxs && "1".equals(zxxs)){
							zxxs = "方向盘";
						}
					 insQuery.setParameter(31,zxxs);
//					 insQuery.setParameter(31,rSet.get("转向形式"));
					 insQuery.setParameter(32,rSet.get("轴数"));
					 insQuery.setParameter(33,rSet.get("轴距"));
					 insQuery.setParameter(34,rSet.get("弹簧片数"));
					 insQuery.setParameter(35,rSet.get("轮胎数"));
					 insQuery.setParameter(36,rSet.get("轮胎规格"));
					 insQuery.setParameter(37,rSet.get("总质量"));
					 insQuery.setParameter(38,rSet.get("整备质量"));
					 insQuery.setParameter(39,rSet.get("挂车质量"));
					 insQuery.setParameter(40,"");
					 insQuery.setParameter(41,rSet.get("前排乘客"));
					 insQuery.setParameter(42,"");
					 insQuery.setParameter(43, "");
					 insQuery.setParameter(44,rSet.get("最高车速"));
					 insQuery.setParameter(45,clsbdh );
					 insQuery.setParameter(46,rSet.get("其它"));
					 insQuery.setParameter(47,frdb);
					 insQuery.setParameter(48,lxr);
					 insQuery.setParameter(49,rSet.get("轴荷"));
					 insQuery.setParameter(50,"");
					 insQuery.setParameter(51,"");
					 insQuery.setParameter(52,rSet.get("批次"));
					 insQuery.setParameter(53,"");
					 insQuery.setParameter(54,rSet.get("防抱死系统"));
					 insQuery.setParameter(55,"");
					 insQuery.setParameter(56,rSet.get("产品号"));
					 
					 String sxrq =  (String) rSet.get("生效日期");
					 if(null!= sxrq && !"".equals(sxrq)){
						 sxrq = sxrq.replace("-", "").replace("&nbsp;", "").replace("</td>", "");
					 }
					 insQuery.setParameter(57,sxrq);
//					 insQuery.setParameter(57,rSet.get("生效日期"));
					 insQuery.setParameter(58,"");
					 insQuery.setParameter(59,"");
					 insQuery.setParameter(60, "");
					 insQuery.setParameter(61,"");
					 insQuery.setParameter(62,"");
					 insQuery.setParameter(63,"");
					 insQuery.setParameter(64, "");
					 insQuery.setParameter(65, "" );
					 insQuery.setParameter(66, "" );
					 insQuery.setParameter(67, "" );
					 insQuery.setParameter(68, "");
					 insQuery.setParameter(69,"");
					 insQuery.executeUpdate();
					 
					 //插入成功后修改标记位
					    String pc = (String) rSet.get("批次");
						String qymcNew = (String) rSet.get("企业名称");
						String clxh = (String) rSet.get("底盘型号");
						String zwpp = (String) rSet.get("产品商标");
						String clmc = (String) rSet.get("产品名称");
						sql = "update nerds.GGCS_ZBZX_DP set flag = '1A' where 批次 = ? and  底盘型号 = ? and 企业名称 = ?  and 产品商标 = ? and 产品名称 = ? ";
//						retrievalJdbcTemplate.update(sql, new Object[]{batchNo,clxh,qymc,zwpp,clmc});
					     insQuery = entityManager.createNativeQuery(sql);
					     insQuery.setParameter(1, pc);
					     insQuery.setParameter(2, clxh);
					     insQuery.setParameter(3, qymcNew);
					     insQuery.setParameter(4, zwpp);
					     insQuery.setParameter(5, clmc);
					     insQuery.executeUpdate();
						
				} catch (Exception e) {
					e.printStackTrace();
					//将插入失败的数据保存到数据表中
					String pc = (String) rSet.get("批次");
					String qymcNew = (String) rSet.get("企业名称");
					String clxh = (String) rSet.get("底盘型号");
					String zwpp = (String) rSet.get("产品商标");
					String clmc = (String) rSet.get("产品名称");
						
					 sql ="insert into nerds.adc_spider_error  values (?,?,?,?,?,?) ";
					
					 Query  insQuery = entityManager.createNativeQuery(sql);
				     insQuery.setParameter(1, pc);
				     insQuery.setParameter(2, clxh);
				     insQuery.setParameter(3, qymcNew);
				     insQuery.setParameter(4, zwpp);
				     insQuery.setParameter(5, clmc);
				     insQuery.setParameter(6, "dp");
				     insQuery.executeUpdate();
				}
			}
	}
	@Transactional  
	public void importZcData() {
		String sql = "SELECT * FROM nerds.GGCS_ZBZX_ZC  WHERE 批次 > '338'  AND flag IS NULL";
		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		for(Map<String, Object> rSet : list){
			String insertSql = "insert into retrieval.clcp_zk (CPNO,企业ID,车辆型号,车辆名称,中文品牌,英文品牌,识别代号,前轮距,后轮距,M发动机,M发企业,M排量,M功率,M发商标,底盘ID1,底盘ID2,底盘ID3,底盘ID4,照片,照片2,照片3,照片4,CPTEMP,产品型号,批次,企业名称,企业地址,注册地址,生产地址,电子信箱,电话号码,传真号码,邮政编码,目录序号,序号目录,长,宽,高,燃料种类,依据标准,转向形式,货厢长,货厢宽,货厢高,轴数,轴距,弹簧片数,轮胎数,轮胎规格,总质量,额定质量,整备质量,挂车质量,载质量,半挂鞍座,额定载客,前排乘客,接近离去角,前悬后悬,驾驶室,传动型式,最高车速,底企型1,底企型2,底企型3,底企型4,其它,制动前,制动后,制操前,制操后,起动方式,CHP说明,CHPSC,法人代表,产品商标,产品类别,轮数,联系人,变更,标记,发布日期,轴荷,油耗,免检,基础,产品类型,排放水平,PICI,KZ,后部照片,侧后防护,防抱死系统,标识型号,标识商标,标识企业,委托加工,委托地址,免检期止,免检说明,产品号,生效日期,CHANG_N,KUAN_N,GAO_N,ZZL_N,EDZL_N,ZBZL_N) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
			// 参数处理--企业id等信息
			             String qyidNew = (String) rSet.get("QY_ID");
			             //方式一：根据企业ID获取法人等信息（暂时废弃）
//						sql = "select * from ggcain06.qyname  where qy_id = ? or adc_qy_id = ? AND zhc_add IS NOT NULL AND mlxh IS NOT NULL AND frdb is not null and address is not null and kt = 'Y' ";
//						Query query2 = entityManager.createNativeQuery(sql.toString());
//						query2.setParameter(1,qyidNew);
//						query2.setParameter(2,qyidNew);
			
			            //方式二：根据企业名称获取法人等信息
						String qyName = (String) rSet.get("企业名称");
						sql = "select * from ggcain06.qyname  where name = ?  AND zhc_add IS NOT NULL AND mlxh IS NOT NULL AND frdb is not null and address is not null and kt = 'Y' ";
						Query query2 = entityManager.createNativeQuery(sql.toString());
						query2.setParameter(1,qyName);
						
						query2.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
						List<Map<String, Object>> queryForList = query2.getResultList();
						
						String qyid = "";
						String address = "";
						String zhc_add = "";
						String email = "";
						String telephone = "";
						String fax = "";
						String postcode = "";
						String mlxh = "";
						String zcxh = "";
						String frdb = "";
						String lxr = "";

						if (queryForList.size() > 0) {
							qyid = (String) queryForList.get(0).get(
									"QY_ID");
							address = (String) queryForList.get(0).get(
									"ADDRESS");
							zhc_add = (String) queryForList.get(0).get(
									"ZHC_ADD");
							email = (String) queryForList.get(0).get(
									"EMAIL");
							telephone = (String) queryForList.get(0)
									.get("TELEPHONE");
							fax = (String) queryForList.get(0).get(
									"FAX");
							postcode = (String) queryForList.get(0)
									.get("POSTCODE");
							mlxh = (String) queryForList.get(0).get(
									"MLXH");
							zcxh = (String) queryForList.get(0).get(
									"ZCXH");
							frdb = (String) queryForList.get(0).get(
									"FRDB");
							lxr = (String) queryForList.get(0).get(
									"LXR");
						}
						// 参数处理--识别代号
						String clsbdh="";
						if(null!=rSet.get("识别代号")){
							clsbdh = ((String) rSet.get("识别代号"))
							.replaceAll(";", " ").replaceAll("；",
									" ");	
						}
						// 参数处理--底盘ID1-底盘ID4
						// String str = "1225472;1222055;1221141";
						String id1 = "";
						String id2 = "";
						String id3 = "";
						String id4 = "";
						if (null != rSet.get("底盘ID")) {
							String[] split = ((String) rSet.get("底盘ID"))
									.split(";");
							if (split.length == 4) {
								id1 = split[0];
								id2 = split[1];
								id3 = split[2];
								id4 = split[3];
							} else if (split.length == 3) {
								id1 = split[0];
								id2 = split[1];
								id3 = split[2];
							} else if (split.length == 2) {
								id1 = split[0];
								id2 = split[1];
							} else if (split.length == 1) {
								id1 = split[0];
							}
						}
						// 参数处理--底企型1--底企型4
						// String str = "1225472;1222055;1221141";
						String did1 = "";
						String did2 = "";
						String did3 = "";
						String did4 = "";
						if (null != rSet.get("底盘型号及企业")) {
							String[] split2 = ((String) rSet.get("底盘型号及企业"))
									.split(";");
							if (split2.length == 4) {
								did1 = split2[0];
								did2 = split2[1];
								did3 = split2[2];
								did4 = split2[3];
							} else if (split2.length == 3) {
								did1 = split2[0];
								did2 = split2[1];
								did3 = split2[2];
							} else if (split2.length == 2) {
								did1 = split2[0];
								did2 = split2[1];
							} else if (split2.length == 1) {
								did1 = split2[0];
							}
						}
						
						try {
							Query insQuery = entityManager.createNativeQuery(insertSql);
							insQuery.setParameter(1,rSet.get("产品ID"));
							insQuery.setParameter(2,qyidNew);
							insQuery.setParameter(3,rSet.get("车辆型号"));
							insQuery.setParameter(4,rSet.get("车辆名称"));
							insQuery.setParameter(5,rSet.get("中文品牌"));
							insQuery.setParameter(6,rSet.get("英文品牌"));
							insQuery.setParameter(7,clsbdh);
							insQuery.setParameter(8,rSet.get("前轮距"));
							insQuery.setParameter(9,rSet.get("后轮距"));
							
							
							String mfdj = (String) rSet.get("发动机型号");
//							if(null!= mfdj){
//								mfdj =  mfdj.replace(" ", ";");
//							}
							
							String fdjqy = (String) rSet.get("发动机生产企业");
//							if(null!= fdjqy){
//								fdjqy =  fdjqy.replace(" ", ";");
//							}
							
							String fdjgl = (String) rSet.get("发动机功率");
//							if(null!= fdjgl){
//								fdjgl =  fdjgl.replace(" ", ";");
//							}	
							
							String fdjpl = (String) rSet.get("排量");
							if(null!= fdjpl){
								fdjpl =  fdjpl.replace(",", ";");
							}								
//							insQuery.setParameter(10,rSet.get("发动机型号"));
//							insQuery.setParameter(11,rSet.get("发动机生产企业"));
//							insQuery.setParameter(12,rSet.get("排量"));
//							insQuery.setParameter(13,rSet.get("发动机功率"));

							insQuery.setParameter(10,rSet.get(mfdj));  //发动机型号
							insQuery.setParameter(11,rSet.get(fdjqy)); //发动机生产企业
							insQuery.setParameter(12,rSet.get(fdjpl)); //排量
							insQuery.setParameter(13,rSet.get(fdjgl)); //发动机功率
							
							String fdjsb = (String) rSet.get("发动机商标");
							if(null!= fdjsb){
								fdjsb =  fdjsb.replace(" ", ";");
							}	
							insQuery.setParameter(14,fdjsb); //发动机商标
							
							insQuery.setParameter(15,id1);
							insQuery.setParameter(16,id2);
							insQuery.setParameter(17,id3);
							insQuery.setParameter(18,id4);
							insQuery.setParameter(19,"");
							insQuery.setParameter(20,"");
							insQuery.setParameter(21,"");
							insQuery.setParameter(22,"");
							insQuery.setParameter(23,rSet.get("车辆型号")+"型"+rSet.get("车辆名称"));
							insQuery.setParameter(24,rSet.get("中文品牌")+""+rSet.get("车辆型号")+"型"+rSet.get("车辆名称"));
							insQuery.setParameter(25,rSet.get("批次"));
							insQuery.setParameter(26,rSet.get("企业名称"));
							insQuery.setParameter(27,address);
							insQuery.setParameter(28,zhc_add);
							insQuery.setParameter(29,rSet.get("生产地址"));
							insQuery.setParameter(30,email);
							insQuery.setParameter(31,telephone);
							insQuery.setParameter(32,fax);
							insQuery.setParameter(33,postcode);
							insQuery.setParameter(34,mlxh);
							insQuery.setParameter(35,zcxh);
							insQuery.setParameter(36,rSet.get("外形尺寸长"));
							insQuery.setParameter(37,rSet.get("外形尺寸宽"));
							insQuery.setParameter(38,rSet.get("外形尺寸高"));
							insQuery.setParameter(39,rSet.get("燃料种类"));
							insQuery.setParameter(40,rSet.get("依据标准"));
							insQuery.setParameter(41,rSet.get("转向形式"));
							insQuery.setParameter(42,rSet.get("货厢长"));
							insQuery.setParameter(43,rSet.get("货厢宽"));
							insQuery.setParameter(44,rSet.get("货厢高"));
							insQuery.setParameter(45,rSet.get("轴数"));
							insQuery.setParameter(46,rSet.get("轴距"));
							insQuery.setParameter(47,rSet.get("弹簧片数"));
							insQuery.setParameter(48,rSet.get("轮胎数"));
							insQuery.setParameter(49,rSet.get("轮胎规格"));
							insQuery.setParameter(50,rSet.get("总质量"));
							insQuery.setParameter(51,rSet.get("额定质量"));
							insQuery.setParameter(52,rSet.get("整备质量"));
							insQuery.setParameter(53,rSet.get("挂车质量"));
							insQuery.setParameter(54,rSet.get("载质量利用系数"));
							insQuery.setParameter(55,rSet.get("半挂鞍座"));
							insQuery.setParameter(56,rSet.get("额定载客"));
							insQuery.setParameter(57,rSet.get("前排乘客"));
							insQuery.setParameter(58,"");
							insQuery.setParameter(59,"");
							insQuery.setParameter(60,"");
							insQuery.setParameter(61,"");
							insQuery.setParameter(62,rSet.get("最高车速"));
							insQuery.setParameter(63,did1);
							insQuery.setParameter(64,did2);
							insQuery.setParameter(65,did3);
							insQuery.setParameter(66,did4);
							insQuery.setParameter(67,rSet.get("其它"));
							insQuery.setParameter(68,"");
							insQuery.setParameter(69,"");
							insQuery.setParameter(70,"");
							insQuery.setParameter(71,"");
							insQuery.setParameter(72,"");
							insQuery.setParameter(73,"");
							insQuery.setParameter(74,"");
							insQuery.setParameter(75,frdb);
							insQuery.setParameter(76,rSet.get("中文品牌"));
							insQuery.setParameter(77,rSet.get("产品类别"));
							insQuery.setParameter(78,"");
							insQuery.setParameter(79,lxr);
							insQuery.setParameter(80,"");
							insQuery.setParameter(81,"");
							 //处理发布日期
							 String fbrq = (String) rSet.get("发布日期");
							 if(null!= fbrq && !"".equals(fbrq)){
								 fbrq = fbrq.replace("-", "").replace("&nbsp;", "").replace("</td>", "");
							 }
							insQuery.setParameter(82,fbrq);
//							insQuery.setParameter(82,rSet.get("发布日期"));
							insQuery.setParameter(83,rSet.get("轴荷"));
							insQuery.setParameter(84,rSet.get("油耗"));
							insQuery.setParameter(85,rSet.get("是否免检"));
							insQuery.setParameter(86,"");
							insQuery.setParameter(87,"");
							insQuery.setParameter(88,"");
							insQuery.setParameter(89,"");
							insQuery.setParameter(90,"");
							insQuery.setParameter(91,"");
							insQuery.setParameter(92,"");
							insQuery.setParameter(93,rSet.get("防抱死系统"));
							insQuery.setParameter(94,rSet.get("反光标识型号"));
							insQuery.setParameter(95,rSet.get("反光标识商标"));
							insQuery.setParameter(96,rSet.get("反光标识企业"));
							insQuery.setParameter(97,"");
							insQuery.setParameter(98,"");
							insQuery.setParameter(99,"");
							insQuery.setParameter(100,"");
							insQuery.setParameter(101,rSet.get("产品号"));
							//处理生效日期
							 String sxrq =  (String) rSet.get("生效日期");
							 if(null!= sxrq && !"".equals(sxrq)){
								 sxrq = sxrq.replace("-", "").replace("&nbsp;", "").replace("</td>", "");
							 }
							insQuery.setParameter(102,sxrq);
//							insQuery.setParameter(102,rSet.get("生效日期"));
							insQuery.setParameter(103,"");
							insQuery.setParameter(104,"");
							insQuery.setParameter(105,"");
							insQuery.setParameter(106,"");
							insQuery.setParameter(107,"");
							insQuery.setParameter(108,"");
							insQuery.executeUpdate();
							//开始处理照片数据
							String pic0 = (String) rSet.get("pic0");
							String pic1 = (String) rSet.get("pic1");
							String pic2 = (String) rSet.get("pic2");
							String pic3 = (String) rSet.get("pic3");
							String pic4 = (String) rSet.get("pic4");
							String pic5 = (String) rSet.get("pic5");
							
							System.out.println("==========begin：获取照片名称============");
							System.out.println(pic0);
							System.out.println(pic1);
							System.out.println(pic2);
							System.out.println(pic3);
							System.out.println(pic4);
							System.out.println(pic5);
							System.out.println("==========end：获取照片名称============");
							
							String pc = (String) rSet.get("批次");
							String qymcNew = (String) rSet.get("企业名称");
							String clxh = (String) rSet.get("车辆型号");
							String zwpp = (String) rSet.get("中文品牌");
							String clmc = (String) rSet.get("车辆名称");
							
							String picResult0 = "";
							String picResult1 = "";
							String picResult2 = "";
							String picResult3 = "";
							String picResult4 = "";
							String picResult5 = "";
							
							List<String> picList = new ArrayList<String>();
							picList.add(pic0);
							picList.add(pic1);
							picList.add(pic2);
							picList.add(pic3);
							picList.add(pic4);
							picList.add(pic5);
							
							for(String picUrl :picList){
								//获取照片名称
								String picName ="";
								String picNumber ="";
								if(picUrl!= null && picUrl.contains("=")){
									String[] split = picUrl.split("=");
									picName = split[split.length-1];
									picNumber = picName.substring(picName.length()-1);
								}
						        System.out.println("picNumber:"+picNumber);
								System.out.println("picName:"+picName);
								// 0--照片 ;   1--照片2 ; 2--照片3 ; 3--照片4 ; 4--后部照片; 5--侧后防护
								if(null!=picNumber && "0".equals(picNumber)){
									picResult0 = picName;
								}
						    	if(null!=picNumber && "1".equals(picNumber)){
						    		picResult1 = picName;
						    	}
						    	if(null!=picNumber && "2".equals(picNumber)){
						    		picResult2 = picName;
						    	}
						    	if(null!=picNumber && "3".equals(picNumber)){
						    		picResult3 = picName;
						    	}
						    	if(null!=picNumber && "4".equals(picNumber)){
						    		picResult4 = picName;
						    	}                       	
						    	if(null!=picNumber && "5".equals(picNumber)){
						    		picResult5 = picName;
						    	}
							}
							sql = "update retrieval.clcp_zk set 照片  = ? ,照片2 = ?,照片3 = ? ,照片4 = ? ,后部照片 = ? ,侧后防护 = ? where 批次 = ? and  车辆型号 = ? and 企业名称 = ?  and 中文品牌 = ? and 车辆名称 = ?";
				    		//retrievalJdbcTemplate.update(sql, new Object[]{picResult0,picResult1,picResult2,picResult3,picResult4,picResult5,batchNo,clxh,qymc,zwpp,clmc});
							 insQuery = entityManager.createNativeQuery(sql);
						     insQuery.setParameter(1,picResult0);
						     insQuery.setParameter(2,picResult1 );
						     insQuery.setParameter(3,picResult2 );
						     insQuery.setParameter(4,picResult3);
						     insQuery.setParameter(5,picResult4);
						     insQuery.setParameter(6,picResult5);
						     insQuery.setParameter(7,pc);
						     insQuery.setParameter(8,clxh);
						     insQuery.setParameter(9,qymcNew);
						     insQuery.setParameter(10,zwpp);
						     insQuery.setParameter(11,clmc);
						     insQuery.executeUpdate();
				    		//插入成功后修改标记位
						    sql = "update nerds.GGCS_ZBZX_ZC set flag = '1A' where 批次 = ? and  车辆型号 = ? and 企业名称 = ?  and 中文品牌 = ? and 车辆名称 = ? ";
//						    retrievalJdbcTemplate.update(sql, new Object[]{batchNo,clxh,qymc,zwpp,clmc});	
						     insQuery = entityManager.createNativeQuery(sql);
						     insQuery.setParameter(1,pc);
						     insQuery.setParameter(2,clxh);
						     insQuery.setParameter(3,qymcNew);
						     insQuery.setParameter(4,zwpp);
						     insQuery.setParameter(5,clmc);
						     
						     insQuery.executeUpdate();
						} catch (Exception e) {
							 //将插入失败的数据保存到数据表中 
							String pc = (String) rSet.get("批次");
							String qymcNew = (String) rSet.get("企业名称");
							String clxh = (String) rSet.get("车辆型号");
							String zwpp = (String) rSet.get("中文品牌");
							String clmc = (String) rSet.get("车辆名称");
							
							 sql ="insert into nerds.adc_spider_error  values (?,?,?,?,?,?) ";
								
							 Query  insQuery = entityManager.createNativeQuery(sql);
						     insQuery.setParameter(1, pc);
						     insQuery.setParameter(2, clxh);
						     insQuery.setParameter(3, qymcNew);
						     insQuery.setParameter(4, zwpp);
						     insQuery.setParameter(5, clmc);
						     insQuery.setParameter(6, "zc");
						     insQuery.executeUpdate();
						}
		}
	}

	public void importZcPicData() {
		String sql  = "SELECT * FROM nerds.GGCS_ZBZX_ZC  WHERE 批次 > '338' and flag is null";
//		List<Map<String, Object>> queryForList = retrievalJdbcTemplate.queryForList(sql);
		Query query = entityManager.createNativeQuery(sql.toString());
//		query.setParameter(1,username);
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> queryForList = query.getResultList();
		for(Map<String, Object> rSet : queryForList){
			String pic0 = (String) rSet.get("pic0");
            String pic1 = (String) rSet.get("pic1");
			String pic2 = (String) rSet.get("pic2");
			String pic3 = (String) rSet.get("pic3");
			String pic4 = (String) rSet.get("pic4");
			String pic5 = (String) rSet.get("pic5");
			
			String pc = (String) rSet.get("批次");
			String qymcNew = (String) rSet.get("企业名称");
			String clxh = (String) rSet.get("车辆型号");
			String zwpp = (String) rSet.get("中文品牌");
			String clmc = (String) rSet.get("车辆名称");
			
			dealPic(pic0,pc,qymcNew,clxh,zwpp,clmc);
			dealPic(pic1,pc,qymcNew,clxh,zwpp,clmc);
			dealPic(pic2,pc,qymcNew,clxh,zwpp,clmc);
			dealPic(pic3,pc,qymcNew,clxh,zwpp,clmc);
			dealPic(pic4,pc,qymcNew,clxh,zwpp,clmc);
			dealPic(pic5,pc,qymcNew,clxh,zwpp,clmc);
			
		} 
	
	}

  	private void dealPic(String  picUrl,String batchNo,String qymc,String clxh,String brand,String clmc){
		//获取照片名称
		String picName ="";
		String picNumber ="";
		if(picUrl!= null && picUrl.contains("=")){
			String[] split = picUrl.split("=");
			picName = split[split.length-1];
			picNumber = picName.substring(picName.length()-1);
		}
//      System.out.println("picNumber:"+picNumber);
//		System.out.println("picName:"+picName);
		 //new一个URL对象  
        URL url;
		try {
			if(null!= picUrl){
				url = new URL(picUrl);
				 //打开链接  
		        HttpURLConnection conn = (HttpURLConnection)url.openConnection();  
		        //设置请求方式为"GET"  
		        conn.setRequestMethod("GET");  
		        //超时响应时间为5秒  
		        conn.setConnectTimeout(5 * 1000);  
		        //通过输入流获取图片数据  
		        InputStream inStream = conn.getInputStream();  
		        //得到图片的二进制数据，以二进制封装得到数据，具有通用性  
		        byte[] data = readInputStream(inStream);  
		        //new一个文件对象用来保存图片，默认保存当前工程根目录  
		        
		       String filePath = "/root/3310a/spiderPic/"+batchNo;
		       File dir = new File(filePath);
		       try {
		    	    //判断文件目录是否存在,不存在就创建
		            if(!dir.exists() && !dir.isDirectory()){
		                dir.mkdir();
		            }
			       } catch (Exception e) {
				  e.printStackTrace();
			     } 
		       
		        File imageFile = new File("/root/3310a/spiderPic"+"/"+batchNo+"/"+picName+".jpg");             //更换12：保存照片路径！！！
//		        File imageFile = new File("D:\\pic\\"+picName+".jpg");  
		        //创建输出流  
		        FileOutputStream outStream = new FileOutputStream(imageFile);  
		        //写入数据  
		        outStream.write(data);  
		        //关闭输出流  
		        outStream.close();  
			}
		} catch (Exception e) {
			e.printStackTrace();
		}  
	}

 	 public byte[] readInputStream(InputStream inStream) throws Exception{  
	        ByteArrayOutputStream outStream = new ByteArrayOutputStream();  
	        //创建一个Buffer字符串  
	        byte[] buffer = new byte[1024];  
	        //每次读取的字符串长度，如果为-1，代表全部读取完毕  
	        int len = 0;  
	        //使用一个输入流从buffer里把数据读取出来  
	        while( (len=inStream.read(buffer)) != -1 ){  
	            //用输出流往buffer里写入数据，中间参数代表从哪个位置开始读，len代表读取的长度  
	            outStream.write(buffer, 0, len);  
	        }  
	        //关闭输入流  
	        inStream.close();  
	        //把outStream里的数据写入内存  
	        return outStream.toByteArray();  
	    }
 	 
 	@Transactional
	public void dealCpsb() {
		//大众汽车(VOLKSWAGEN)牌
		String sql  = "SELECT cpno,产品号, 中文品牌,英文品牌,产品商标,批次 FROM retrieval.clcp_zk   where 英文品牌 is not null and 批次 > '338' ";
		//T4143388	AMUZP6PA05X	福达牌	FORTA	福达牌	339
//		List<Map<String, Object>> queryForList = retrievalJdbcTemplate.queryForList(sql);
		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> queryForList = query.getResultList();
		for(Map<String, Object> rSet : queryForList){
			String result = "";
			String cpno = (String) rSet.get("CPNO");
			String cph = (String) rSet.get("产品号");
			String zwpp = (String) rSet.get("中文品牌");
			String ywpp = (String) rSet.get("英文品牌");
			result = zwpp.replace("牌", "") + "(" + ywpp +")牌";
			sql = "update retrieval.clcp_zk set 产品商标 = ? where cpno = ? and 产品号 = ? and 批次 > '338' "; 
//			retrievalJdbcTemplate.update(sql,new Object[]{result,cpno,cph});
			Query insQuery = entityManager.createNativeQuery(sql);
			insQuery.setParameter(1,result);
			insQuery.setParameter(2,cpno);
			insQuery.setParameter(3,cph);
			insQuery.executeUpdate();
		}
	}  
@Transactional
    public void updateRetUserStatusD(Map<String, Object> res) {
        String updSql = " UPDATE RETRIEVAL.RET_USERS SET RESULT = 'D' WHERE (RESULT <>'Y' OR RESULT IS NULL) AND USERNAME= ? ";
        Query insQuery = entityManager.createNativeQuery(updSql);
        insQuery.setParameter(1, res.get("USERNAME"));
        int i= insQuery.executeUpdate();

        // nerds.password_qy 插入
        String insSql = " INSERT INTO NERDS.PASSWORD_QY  VALUES (?, ?, ?, 'Y',sysdate, ?,RETRIEVAL_SEQ.nextval)";
        insQuery = entityManager.createNativeQuery(insSql);
        insQuery.setParameter(1, res.get("NAME")==null?"":res.get("NAME").toString());
        insQuery.setParameter(2, res.get("gxbpassword")==null?"":res.get("gxbpassword").toString());
        insQuery.setParameter(3, res.get("USERNAME")==null?"":res.get("USERNAME").toString());
	insQuery.setParameter(4, res.get("gxbusername")==null?"":res.get("gxbusername").toString());

	insQuery.executeUpdate();

    }

    @Transactional
    public void updateRetUserStatusY(Map<String, Object> res) {
        String updSql = " UPDATE RETRIEVAL.RET_USERS SET RESULT = 'Y' WHERE (RESULT ='D' OR RESULT IS NULL) AND USERNAME= ? ";
        Query insQuery = entityManager.createNativeQuery(updSql);
        insQuery.setParameter(1, res.get("username"));
        insQuery.executeUpdate();
    }

	@Transactional
	public void pushZcPicFile() {

		try {
			ItransferfilesService service = new ItransferfilesService();
			String sql  = "SELECT * FROM nerds.GGCS_ZBZX_ZC WHERE 批次 > '338' and flag is null ";
			Query query = entityManager.createNativeQuery(sql.toString());
			query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
			List<Map<String, Object>> queryForList = query.getResultList();

			for(Map<String, Object> rSet : queryForList){
				String pic0 = (String) rSet.get("pic0")==null?"":rSet.get("pic0").toString();
				String pic1 = (String) rSet.get("pic1")==null?"":rSet.get("pic1").toString();
				String pic2 = (String) rSet.get("pic2")==null?"":rSet.get("pic2").toString();
				String pic3 = (String) rSet.get("pic3")==null?"":rSet.get("pic3").toString();
				String pic4 = (String) rSet.get("pic4")==null?"":rSet.get("pic4").toString();
				String pic5 = (String) rSet.get("pic5")==null?"":rSet.get("pic5").toString();

				String pc = (String) rSet.get("批次");

				// 推送数据
				pushPic(pic0, pc, service);
				pushPic(pic1, pc, service);
				pushPic(pic2, pc, service);
				pushPic(pic3, pc, service);
				pushPic(pic4, pc, service);
				pushPic(pic5, pc, service);

			}
		} catch (Exception e) {
			System.out.println("error**************"+e.getMessage());
			e.printStackTrace();
		}
	}

	private void pushPic(String picUrl, String pc, ItransferfilesService service) {
		if(StringUtils.isNotBlank(picUrl) && StringUtils.isNotBlank(pc)){

			try {
				DataAndFilesLogs datafiles = new DataAndFilesLogs();
				Transferfiles tf = new Transferfiles();
				//根据路径获取文件
				byte[] buffer = null;
				// TEST
				String[] split = picUrl.split("=");
				String picName = split[split.length-1];
				//String filepath = "D:\\pic\\"+picName+".jpg";
				// 实际服务器文件路径
				String fileRealpath = "/root/3310a/spiderPic"+"/"+pc+"/"+picName+".jpg";

				String fileAdcpath = "/3310b/ggpic/mlsw/"+picName+".jpg";
				// 获取文件数据
				File f = new File(fileRealpath);

				// 如果文件存在，需要调用远程接口推送
				if (f.exists()) {
					InputStream is = null;
					try {
						is = new FileInputStream(f);
						buffer = new byte[is.available()];
						is.read(buffer);
					} catch (Exception ex) {
					} finally {
						if (is != null) {
							try {
								is.close();
							} catch (IOException ex) {

							}
						}
					}
					tf.setBuffer(buffer);
					tf.setPath(fileAdcpath);

					// 调用接口推送
					String result = service.getItransferfilesPort().pushTransferFiles(tf);

					// result：1(正常);2(数据流不存在);3(服务器端文件存在);4(异常);5(推送方文件不存在)
					datafiles.setType(result);
				} else {
					datafiles.setType("5");
				}
				datafiles.setPath(picUrl);

				int i = insertDataAndFilesLogs(entityManager, datafiles);
				System.out.println("insert cnt:"+ i);

			} catch (Exception ex) {
				// 保存异常信息
				DataAndFilesLogs datafiles = new DataAndFilesLogs();
				datafiles.setPath(picUrl);
				datafiles.setException(ex.getMessage());
				datafiles.setType("4");

				int i = insertDataAndFilesLogs(entityManager, datafiles);
				System.out.println("insert cnt:"+ i);
			}

		}
	}

	@Transactional
	public int insertDataAndFilesLogs(EntityManager entityManager, DataAndFilesLogs datafiles) {
		String insSql = " INSERT INTO ggcain06.Dataandfileslogs(path,type,exception,time)  VALUES (?, ?, ?, sysdate)";
		Query insQuery = entityManager.createNativeQuery(insSql);
		insQuery.setParameter(1, datafiles.getPath());
		insQuery.setParameter(2, datafiles.getType());
		insQuery.setParameter(3, datafiles.getException());
		return insQuery.executeUpdate();
	}
}

