package com.adc.da.bs.login.service;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.adc.da.communal.Utils.DateUtils;
import com.adc.da.util.exception.AdcDaBaseException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.adc.da.bs.login.dao.LoginDao;
import com.adc.da.util.http.PageParam;

import javax.servlet.http.HttpServletRequest;

/**
 * 推荐目录Service
 * zhong
 * 2018-3-22
 */
@Service
public class LoginService {
	private final Logger logger = LoggerFactory.getLogger(getClass());
	@Autowired
	private LoginDao loginDao;

	public Map<String, Object> findMap(String username) {
		Map<String, Object> remap =loginDao.findMap(username);
        
		return remap;
	}

	public Map<String, Object> checkUserLogin(HttpServletRequest request){
		Map<String, Object> usermap = (Map)request.getSession().getAttribute("usermap");
		if(usermap == null || usermap.isEmpty()){
			logger.error(DateUtils.getDate("yyyy-MM-dd HH:mm:ss", new Date())+ "用户未登录");
			throw new AdcDaBaseException("未登录用户，请先登陆！");
		}

		return usermap;
	}
	/**
     * 从字典表查询NERDS的参数项目
     *
     * @param partId
     * @return
     *//*
	public List<Map<String, Object>> getNerdsParamItems(String partId) {
		 return this.nerdsDao.getNerdsParamItems(partId);
	}
	public List<Map<String, Object>> getNerdsParamData(String p_id,
			String p_model, String type) {
		return this.nerdsDao.getNerdsParamData(p_id,p_model,type);
	}
	public List<Map<String, Object>> getCollocations(String p_id,
			String p_model, String type) {
		return this.nerdsDao.getCollocations(p_id, p_model, type);
	}
	
	*/

	public void access(Map<String, Object> res) {
		loginDao.access(res);
	}

	/**   
	 * @Title: getresult   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qyid
	 * @param @return    设定文件   
	 * @return String    返回类型   
	 * @author ADC_ZH 
	 * @date 上午10:36:16 
	*/   
	public String getresult(String qyid) {
		// TODO Auto-generated method stub
		return loginDao.getresult(qyid);
	}
	
}
