package com.adc.da.bs.nerds.dao;

import java.util.List;
import java.util.Map;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.adc.da.util.http.PageParam;
/*import com.adc.da.enterprise.entity.EncodeRuleBasicEO;
import com.adc.da.enterprise.entity.EnterpriseAppEO;
import com.adc.da.enterprise.entity.EnterpriseEO;*/

/**
 * 推荐目录Dao
 * zhong
 * 2018-3-22
 */


@Component
public class NerdsDao{
	protected final EntityManager entityManager;
	@Autowired
	public NerdsDao(EntityManager entityManager) {
		super();
        this.entityManager = entityManager;
	}
 
	public List<Map<String, Object>> findPage(PageParam page,
			Map<String, Object> map) {
        StringBuilder queryBuilder = new StringBuilder(" SELECT ROWNUM COU ,T.* FROM ( ");
        queryBuilder.append(" select pc,c. CPID,NVL (c.CLXH, ' ') CLXH,NVL (c.CLCPMC, ' ') CLCPMC,");
        queryBuilder.append(" NVL (c.CLSB, ' ') CLSB, NVL (c.CLLB, ' ') CLLB, NVL (c.SFSCKC, ' ') SFSCKC,");
        queryBuilder.append(" NVL (c.SFSYCL, ' ') SFSYCL,NVL (q1.qymc, ' ') qymc ");
        queryBuilder.append(" FROM nerds.zk_clxx c LEFT JOIN nerds.qyxx q1 ON q1.sbqyid = c.qyid");
        queryBuilder.append(" WHERE 1 = 1 ");
        if ("N".equals(map.get("type"))){
            queryBuilder.append("  and gzkzlb ='X' ");
        }
        else {
        	queryBuilder.append("  and gzkzlb ='G' ");
        }
        queryBuilder.append(" and pc=(SELECT TO_CHAR(MAX(TO_NUMBER(pc))) FROM nerds.zk_clxx) ");
        if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
        	queryBuilder.append(" AND c.CLXH like '%"+map.get("xh").toString()+"%' ");
        }
        if(map.get("mc")!=null&&!"".equals(map.get("mc"))){
        	queryBuilder.append(" AND c.CLCPMC like '%"+map.get("mc").toString()+"%'");
        }
        if(map.get("sb")!=null&&!"".equals(map.get("sb"))){
        	queryBuilder.append(" AND c.CLSB like '%"+map.get("sb").toString()+"%'");
        }
        if(map.get("lx")!=null&&!"".equals(map.get("lx"))){
        	queryBuilder.append(" AND c.CLLB like '%"+map.get("lx").toString()+"%'");
        }
        if(map.get("qyid")!=null&&!"".equals(map.get("qyid"))){
        	queryBuilder.append(" AND q1.qyid = '"+map.get("qyid").toString()+"'");
        }
        queryBuilder.append(" order by c.RK_TIME desc ");
        queryBuilder.append(" ) T ");
        Query query = entityManager.createNativeQuery(queryBuilder.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
		return list;
	}


	public Long findPageCount(Map<String, Object> map) {
		 StringBuilder queryBuilder = new StringBuilder(" SELECT count(*) FROM ( ");
	        
		 queryBuilder.append(" select pc,c. CPID,NVL (c.CLXH, ' ') CLXH,NVL (c.CLCPMC, ' ') CLCPMC,");
	        queryBuilder.append(" NVL (c.CLSB, ' ') CLSB, NVL (c.CLLB, ' ') CLLB, NVL (c.SFSCKC, ' ') SFSCKC,");
	        queryBuilder.append(" NVL (c.SFSYCL, ' ') SFSYCL,NVL (q1.qymc, ' ') qymc ");
	        queryBuilder.append(" FROM nerds.zk_clxx c LEFT JOIN nerds.qyxx q1 ON q1.sbqyid = c.qyid");
	        queryBuilder.append(" WHERE 1 = 1 ");
	        if ("N".equals(map.get("type"))){
	            queryBuilder.append("  and gzkzlb ='X' ");
	        }
	        else {
	        	queryBuilder.append("  and gzkzlb ='G' ");
	        }
	        queryBuilder.append(" and pc=(SELECT TO_CHAR(MAX(TO_NUMBER(pc))) FROM nerds.zk_clxx) ");
	        if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
	        	queryBuilder.append(" AND c.CLXH like '%"+map.get("xh").toString()+"%' ");
	        }
	        if(map.get("mc")!=null&&!"".equals(map.get("mc"))){
	        	queryBuilder.append(" AND c.CLCPMC like '%"+map.get("mc").toString()+"%'");
	        }
	        if(map.get("sb")!=null&&!"".equals(map.get("sb"))){
	        	queryBuilder.append(" AND c.CLSB like '%"+map.get("sb").toString()+"%'");
	        }
	        if(map.get("lx")!=null&&!"".equals(map.get("lx"))){
	        	queryBuilder.append(" AND c.CLLB like '%"+map.get("lx").toString()+"%'");
	        }
	        if(map.get("qyid")!=null&&!"".equals(map.get("qyid"))){
	        	queryBuilder.append(" AND q1.qyid = '"+map.get("qyid").toString()+"'");
	        }
	        queryBuilder.append(" order by c.RK_TIME desc ");
	        queryBuilder.append(" ) T ");
        Query query = entityManager.createNativeQuery(queryBuilder.toString());
        Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}
	public List<Map<String, Object>> getNerdsParamItems(String partId) {
		String sql = "select ROWNUM COU,t.* from nerds.D_JSCS t where t.seq in( '1005' ,'10051','10052'"
				+ ",'1014','1015','1016','1017','1022','1023','1024','1025','1033','1039','1043' "
				+ ",'1050','1051','1052','1054','1056','1057','1058','1059','1060','1061','1062' "
				+ ",'1006','1007','1008','1010','1012','1013','1063','1065','1066') order by t.seq";
		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		return list;
	}

	public List<Map<String, Object>> getNerdsParamData(String p_id,
			String p_model, String type) {
		String sql = "N".equals(type) ? "select  bj.clid, bj.clxh, bj.jscs_seq, bj.jscs_val, bj.pz_id  from nerds.zk_jscs bj where clid = ? and clxh = ?"
                : ("G".equals(type) ? " select  bj.clid, bj.clxh, bj.jscs_seq, bj.fieldyvalue, bj.fieldhvalue, bj.pz_id  from nerds.GZKZ_JSCS bj where clid = ? and clxh = ? " : "SELECT * from nerds.zk_jscs where clid = ? and clxh = ?") ;
		Query query = entityManager.createNativeQuery(sql.toString());
		query.setParameter(1,p_id);
		query.setParameter(2,p_model);
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		return list;
	}

	public List<Map<String, Object>> getCollocations(String p_id,
			String p_model, String type) {
		 String sql = "N".equals(type) ? "select distinct(pz_id) pz_id from nerds.ZK_JSCS where clid = ? and clxh = ?" :
             ("G".equals(type) ? " select distinct(pz_id) pz_id from nerds.GZKZ_JSCS where clid = ? and clxh = ? " : "select distinct(pz_id) pz_id from nerds.ZK_JSCS where clid = ? and clxh = ? " );
		 Query query = entityManager.createNativeQuery(sql.toString());
			query.setParameter(1,p_id);
			query.setParameter(2,p_model);
			query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
			List<Map<String, Object>> list = query.getResultList();
			return list;
	}

	/**   
	 * @Title: gzsList   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @param map
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 上午11:44:38 
	*/   
	public List<Map<String, Object>> gzsList(PageParam page,
			Map<String, Object> map) {
		
		StringBuilder queryBuilder = new StringBuilder("select * FROM "+map.get("table")+"  where 1=1 ");  
        if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
        	queryBuilder.append(" AND 车辆型号 like :xh ");
        }
        if(map.get("cpmc")!=null&&!"".equals(map.get("cpmc"))){
        	queryBuilder.append(" AND 产品名称 like :cpmc ");
        }
        if(map.get("qymc")!=null&&!"".equals(map.get("qymc"))){
        	queryBuilder.append(" AND 汽车生产企业名称 like :qymc");
        } 
        if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
        	queryBuilder.append(" AND 批次= :pc");
        }
        queryBuilder.append(" order by 批次  desc ,汽车生产企业名称,车辆型号  desc "); 
        Query query = entityManager.createNativeQuery(queryBuilder.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
        	query.setParameter("xh", "%"+map.get("xh")+"%");
        }
        if(map.get("cpmc")!=null&&!"".equals(map.get("cpmc"))){
        	query.setParameter("cpmc", "%"+map.get("cpmc")+"%");
        }
        if(map.get("qymc")!=null&&!"".equals(map.get("qymc"))){
        	query.setParameter("qymc", "%"+map.get("qymc")+"%");
        } 
        if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
        	query.setParameter("pc",map.get("pc"));
        }
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
		return list;
	}

	/**   
	 * @Title: gzsListCount   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param map
	 * @param @return    设定文件   
	 * @return Long    返回类型   
	 * @author ADC_ZH 
	 * @date 下午1:48:35 
	*/   
	public Long gzsListCount(Map<String, Object> map) {
		StringBuilder queryBuilder = new StringBuilder("select count(*) FROM "+map.get("table")+"  where 1=1 ");  
		if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
			queryBuilder.append(" AND 车辆型号 like :xh ");
		}
		if(map.get("cpmc")!=null&&!"".equals(map.get("cpmc"))){
			queryBuilder.append(" AND 产品名称 like :cpmc ");
		}
		if(map.get("qymc")!=null&&!"".equals(map.get("qymc"))){
			queryBuilder.append(" AND 汽车生产企业名称 like :qymc");
		} 
        if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
        	queryBuilder.append(" AND 批次= :pc");
        }
		Query query = entityManager.createNativeQuery(queryBuilder.toString());
 		if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
        	query.setParameter("xh", "%"+map.get("xh")+"%");
        }
        if(map.get("cpmc")!=null&&!"".equals(map.get("cpmc"))){
        	query.setParameter("cpmc", "%"+map.get("cpmc")+"%");
        }
        if(map.get("qymc")!=null&&!"".equals(map.get("qymc"))){
        	query.setParameter("qymc", "%"+map.get("qymc")+"%");
        } 
        if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
        	query.setParameter("pc",map.get("pc"));
        }
		Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}

	/**   
	 * @Title: ccsList   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @param map
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午4:18:43 
	*/   
	public List<Map<String, Object>> ccsList(PageParam page,
			Map<String, Object> map) {
		StringBuilder queryBuilder = new StringBuilder("select * FROM "+map.get("table")+" where 1=1 ");  
        if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
        	queryBuilder.append(" AND "+map.get("xhname")+" like :xh ");
        }
        if(map.get("cpmc")!=null&&!"".equals(map.get("cpmc"))){
        	queryBuilder.append(" AND 产品名称 like :cpmc ");
        }
        if(map.get("qymc")!=null&&!"".equals(map.get("qymc"))){
        	queryBuilder.append(" AND 企业名称 like :qymc");
        }
        if(map.get("sb")!=null&&!"".equals(map.get("sb"))){
        	queryBuilder.append(" AND 商标 like :sb");
        }
        if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
        	queryBuilder.append(" AND 批次= :pc");
        }
        queryBuilder.append(" order by 批次   desc ,企业名称, "+map.get("xhname")+"  desc "); 
        Query query = entityManager.createNativeQuery(queryBuilder.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
 		if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
        	query.setParameter("xh", "%"+map.get("xh")+"%");
        }
        if(map.get("cpmc")!=null&&!"".equals(map.get("cpmc"))){
        	query.setParameter("cpmc", "%"+map.get("cpmc")+"%");
        }
        if(map.get("qymc")!=null&&!"".equals(map.get("qymc"))){
        	query.setParameter("qymc", "%"+map.get("qymc")+"%");
        }
        if(map.get("sb")!=null&&!"".equals(map.get("sb"))){
        	query.setParameter("sb", "%"+map.get("sb")+"%" );
        }
        if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
        	query.setParameter("pc",map.get("pc"));
        }
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
		return list;
	}

	/**   
	 * @Title: ccsListCount   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param map
	 * @param @return    设定文件   
	 * @return Long    返回类型   
	 * @author ADC_ZH 
	 * @date 下午4:19:55 
	*/   
	public Long ccsListCount(Map<String, Object> map) {
		StringBuilder queryBuilder = new StringBuilder("select count(*) FROM "+map.get("table")+"  where 1=1 ");  
        if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
        	queryBuilder.append(" AND "+map.get("xhname")+"  like :xh ");
        }
        if(map.get("cpmc")!=null&&!"".equals(map.get("cpmc"))){
        	queryBuilder.append(" AND 产品名称 like :cpmc ");
        }
        if(map.get("qymc")!=null&&!"".equals(map.get("qymc"))){
        	queryBuilder.append(" AND 企业名称 like :qymc");
        }
        if(map.get("sb")!=null&&!"".equals(map.get("sb"))){
        	queryBuilder.append(" AND 商标 like :sb");
        }
        if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
        	queryBuilder.append(" AND 批次= :pc");
        }
        Query query = entityManager.createNativeQuery(queryBuilder.toString());
 		if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
        	query.setParameter("xh", "%"+map.get("xh")+"%");
        }
        if(map.get("cpmc")!=null&&!"".equals(map.get("cpmc"))){
        	query.setParameter("cpmc", "%"+map.get("cpmc")+"%");
        }
        if(map.get("qymc")!=null&&!"".equals(map.get("qymc"))){
        	query.setParameter("qymc", "%"+map.get("qymc")+"%");
        }
        if(map.get("sb")!=null&&!"".equals(map.get("sb"))){
        	query.setParameter("sb", "%"+map.get("sb")+"%" );
        }
        if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
        	query.setParameter("pc",map.get("pc"));
        }
		Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}

	/**   
	 * @Title: findTjmlColumn   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午1:06:47 
	*/   
	public List<Map<String, Object>> findTjmlColumn() {
		StringBuilder queryBuilder = new StringBuilder("select * FROM nerds.tjmu_zd_gx where enable='Y' ");    
        Query query = entityManager.createNativeQuery(queryBuilder.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
		return list;
	}

	/**   
	 * @Title: TjmlPc   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午1:20:57 
	*/   
	public List<Map<String, Object>> TjmlPc() {
		StringBuilder queryBuilder = new StringBuilder("select * FROM nerds.tjmu_pc_gx ORDER BY TO_NUMBER(PC) DESC");    
        Query query = entityManager.createNativeQuery(queryBuilder.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
		return list;
	}

	/**   
	 * @Title: tjmlList   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @param map
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午1:38:00 
	*/   
	public List<Map<String, Object>> tjmlList(PageParam page,
			Map<String, Object> map) {
		StringBuilder queryBuilder = new StringBuilder("select DISTINCT p.SHOWPC,z.cp_id ,z.clcpmc,z.clxh,z.qymc,z.cllb ");  
		queryBuilder.append(" FROM nerds.zk_all_fab z LEFT JOIN  nerds.tjmu_pc_gx p ON z.pc=p.pc where 1=1 ");
		if(map.get("type")!=null&&!"".equals(map.get("type"))){
			queryBuilder.append(" AND z.gzkzlb = :type ");
		}
		if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
			queryBuilder.append(" AND z.clxh like :xh ");
		}
		if(map.get("mc")!=null&&!"".equals(map.get("mc"))){
			queryBuilder.append(" AND z.clcpmc like :mc ");
		}
		if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
			queryBuilder.append(" AND z.pc= :pc ");
		}
		if(map.get("qyid")!=null&&!"".equals(map.get("qyid"))){
			queryBuilder.append(" AND z.qy_id= :qyid ");
		} 
		queryBuilder.append(" order by p.SHOWPC  desc,  z.clxh ");
		Query query = entityManager.createNativeQuery(queryBuilder.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		if(map.get("type")!=null&&!"".equals(map.get("type"))){
			query.setParameter("type", map.get("type"));
		}
		if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
			query.setParameter("xh", "%"+map.get("xh")+"%");
		}
		if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
			query.setParameter("pc", map.get("pc"));
		}		
		if(map.get("mc")!=null&&!"".equals(map.get("mc"))){
			query.setParameter("mc", "%"+map.get("mc")+"%");
		}
		if(map.get("qyid")!=null&&!"".equals(map.get("qyid"))){
			query.setParameter("qyid", map.get("qyid"));
		}
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
		return list;
	}

	/**   
	 * @Title: tjmlListCount   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param map
	 * @param @return    设定文件   
	 * @return Long    返回类型   
	 * @author ADC_ZH 
	 * @date 下午2:26:24 
	*/   
	public Long tjmlListCount(Map<String, Object> map) {
		StringBuilder queryBuilder = new StringBuilder("select count(DISTINCT cp_id) FROM nerds.zk_all_fab where 1=1 ");  
		if(map.get("type")!=null&&!"".equals(map.get("type"))){
			queryBuilder.append(" AND gzkzlb = :type ");
		}
		if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
			queryBuilder.append(" AND clxh like :xh ");
		}
		if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
			queryBuilder.append(" AND pc= :pc ");
		}
		if(map.get("mc")!=null&&!"".equals(map.get("mc"))){
			queryBuilder.append(" AND  clcpmc like :mc ");
		}
		if(map.get("qyid")!=null&&!"".equals(map.get("qyid"))){
			queryBuilder.append(" AND qy_id= :qyid ");
		} 
        Query query = entityManager.createNativeQuery(queryBuilder.toString());
        if(map.get("type")!=null&&!"".equals(map.get("type"))){
			query.setParameter("type", map.get("type"));
		}
		if(map.get("xh")!=null&&!"".equals(map.get("xh"))){
			query.setParameter("xh", "%"+map.get("xh")+"%");
		}
		if(map.get("pc")!=null&&!"".equals(map.get("pc"))){
			query.setParameter("pc", map.get("pc"));
		}
		if(map.get("mc")!=null&&!"".equals(map.get("mc"))){
			query.setParameter("mc", "%"+map.get("mc")+"%");
		}
		if(map.get("qyid")!=null&&!"".equals(map.get("qyid"))){
			query.setParameter("qyid", map.get("qyid"));
		}
		Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}

	/**   
	 * @Title: tjmlList   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param cp_id
	 * @param @param tjmlColumn
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午2:42:36 
	*/   
	public List<Map<String, Object>> tjmlDetail(String cp_id,
			List<Map<String, Object>> tjmlColumn) {
		StringBuilder queryBuilder = new StringBuilder("select * "); 
		queryBuilder.append("  FROM nerds.zk_all_fab where 1=1 ");
		if(cp_id!=null&&!"".equals(cp_id)){
			queryBuilder.append(" AND cp_id = :cp_id ");
		} 
		Query query = entityManager.createNativeQuery(queryBuilder.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		if(cp_id!=null&&!"".equals(cp_id)){
			query.setParameter("cp_id",cp_id);
		}
        List<Map<String, Object>> list = query.getResultList();

		return list;
	}


}
