package com.adc.da.bs.webservice.dao;

import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.Map;


@Component
public class ZbzxGgcsDao{
	protected static EntityManager entityManager;
	@Autowired
	public ZbzxGgcsDao(EntityManager entityManager) {
		super();
        this.entityManager = entityManager;
	}
	
	@Transactional
	public int insert(String sql){
		int dpCount = 0;
		Query query = entityManager.createNativeQuery(sql);
		try {
			dpCount = query.executeUpdate();
			if(dpCount>0){            				
				System.out.println("插入成功");
			}
		} catch (Exception e) {
			e.printStackTrace();
			
		}
		return dpCount;
		
	}
	
	@Transactional
	public int insertE(String sql) {
		try {
			System.out.println("插入不不不成功" + sql);
			String SqlE = "insert into NERDS.GGCS_ZBZX_EXCEPTION  ( EXCEPTION,CREATE_TIME) values (?,SYSDATE)";
			Query query = entityManager.createNativeQuery(SqlE);

			query.setParameter(1, sql);

			query.executeUpdate();

		} catch (Exception e) {
			e.printStackTrace();
		}
		return 0;

	}

	public int findMaxPcCount() {
			String max_pc="SELECT TO_CHAR(MAX(TO_NUMBER(\"批次\"))) PC FROM RETRIEVAL.clcp_zk";
			Query query2 = entityManager.createNativeQuery(max_pc);
			query2.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
			Map<String, Object> list1 = (Map<String, Object>) query2.getResultList().get(0);
			String pc=list1.get("PC").toString();
		return Integer.parseInt(pc);
	}

}