package com.adc.da.bs.param.dao;

import com.adc.da.bs.param.entity.SearchProductParams;
import com.adc.da.util.http.PageParam;

import org.apache.commons.lang3.StringUtils;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import java.io.File;
import java.util.*;

/**
 * 车型参数Dao
 * zhong
 * 2018-3-14
 */


@Component
public class ParamDao{
	protected final EntityManager entityManager;
	@Autowired
	public ParamDao(EntityManager entityManager) {
		super();
        this.entityManager = entityManager;
	}


	@SuppressWarnings("unchecked")
	public List<Map<String, Object>> findPage(PageParam page,String pc, String qyid, String cpsb, String rlzl, String qymc) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select t.* , rownum rn from (select  * from ");
		sql.append(" ( ");
		sql.append(" select a.燃料种类 rlzl , a.企业ID as qy_id, a.产品号 as cph, a.cpno, a.车辆名称 as clmc,a.中文品牌  as cppp, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.clcp_zk a ");//车辆产品总库
//		sql.append(" where a.批次 =:pc");
		sql.append(" where 1= 1 ");
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc ");
		}

		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid)  or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称  like :qymc");
		}
		sql.append(" union ");
		sql.append(" select a.燃料种类 rlzl , a.企业ID as qy_id, a.产品号 as cph, a.dpid, a.产品名称 as clmc,a.产品商标 as cppp, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.chpdpk_zk a ");//底盘总库
//		sql.append(" where a.批次 =:pc");
		sql.append(" where 1= 1 ");
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc ");
		}
		if(qyid!=null && !"".equals(qyid)){
			
			sql.append(" and (a.企业ID =:qyid or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid)  or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");
//sql.append(" and a.企业ID =:qyid");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标=:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称  like :qymc");
		}
		/*sql.append(" union ");
		sql.append(" select a.燃料种类 rlzl ,  a.企业ID as qy_id, a.产品号 as cph, a.cpno, a.车辆名称 as clmc,a.中文品牌  as cppp, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.clcp_zk_NEW a ");//车辆产品总库-2021爬取
		sql.append(" where a.批次 =:pc");
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		sql.append(" union ");
		sql.append(" select  a.燃料种类 rlzl , a.企业ID as qy_id, a.产品号 as cph, a.dpid, a.产品名称 as clmc,a.产品商标 as cppp, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.chpdpk_zk_NEW a ");//底盘总库-2021爬取
		sql.append(" where a.批次 =:pc");
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}*/
		sql.append(" ) z where 1=1 ");
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND ggsxrq >=:startTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND ggsxrq <=:endTime ");
		} 
		sql.append(" order by qymc, to_number(pc) desc) t");
		
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
//        if(pc==null ||"undefined".equals(pc)||"".equals(pc)){
//        	String max_pc="SELECT TO_CHAR(MAX(TO_NUMBER(\"批次\"))) PC FROM RETRIEVAL.clcp_zk";
//        	Query query2 = entityManager.createNativeQuery(max_pc);
//        	query2.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
//        	Map<String, Object> list1 = (Map<String, Object>) query2.getResultList().get(0);
//        	pc=list1.get("PC").toString();
//        }
//        query.setParameter("pc", pc);
        
        if(pc!=null && !"".equals(pc)){
        	query.setParameter("pc", pc);
        }
        
        if(qyid!=null && !"".equals(qyid)){
            query.setParameter("qyid", qyid);
        }
        if(cpsb!=null && !"".equals(cpsb)){
			query.setParameter("cpsb", cpsb);
		}
        if(rlzl!=null && !"".equals(rlzl)){
			query.setParameter("rlzl", rlzl);
		}
        if(qymc!=null && !"".equals(qymc)){
			query.setParameter("qymc",  "%"+qymc+"%");
		}
        if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
            query.setParameter("startTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
            query.setParameter("endTime", page.getEndTime());
		}
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
		return list;
	}
	
	public Long findPageCount(PageParam page,String pc, String qyid, String cpsb, String rlzl, String qymc) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select count(1) from ");
		sql.append(" ( ");
		sql.append(" select a.燃料种类 rlzl , a.中文品牌  as cppp,a.企业ID as qy_id, a.产品号 as cph, a.cpno, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.clcp_zk a ");
//		sql.append(" where a.批次 =:pc ");
		sql.append(" where 1= 1 ");
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc ");
		}
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid)  or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称  like :qymc");
		}
		sql.append(" union ");
		sql.append(" select  a.燃料种类 rlzl ,a.产品商标 cppp, a.企业ID as qy_id, a.产品号 as cph, a.dpid, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.chpdpk_zk a ");
//		sql.append(" where a.批次 =:pc ");
		sql.append(" where 1= 1 ");
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc ");
		}
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid) or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid))");

		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称  like :qymc");
		}
		/*sql.append(" union ");
		sql.append(" select a.燃料种类 rlzl , a.中文品牌  as cppp, a.企业ID as qy_id, a.产品号 as cph, a.cpno, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.clcp_zk_NEW  a ");
		sql.append(" where a.批次 =:pc ");
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		sql.append(" union ");
		sql.append(" select  a.燃料种类 rlzl ,a.产品商标 cppp, a.企业ID as qy_id, a.产品号 as cph, a.dpid, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.chpdpk_zk_NEW  a ");
		sql.append(" where a.批次 =:pc ");
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标=:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}*/
		sql.append(" ) z where 1=1 ");
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND ggsxrq >=:startTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND ggsxrq <=:endTime ");
		}
        Query query = entityManager.createNativeQuery(sql.toString());
       // query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
//        if(pc==null ||"undefined".equals(pc)||"".equals(pc)){
//        	String max_pc="SELECT TO_CHAR(MAX(TO_NUMBER(\"批次\"))) PC FROM RETRIEVAL.clcp_zk";
//        	Query query2 = entityManager.createNativeQuery(max_pc);
//        	query2.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
//        	Map<String, Object> list1 = (Map<String, Object>) query2.getResultList().get(0);
//        	pc=list1.get("PC").toString();
//        }
//        query.setParameter("pc", pc);
        
        if(pc!=null && !"".equals(pc)){
        	query.setParameter("pc", pc);
        }
        
        if(qyid!=null && !"".equals(qyid)){
            query.setParameter("qyid", qyid);
        }
        if(cpsb!=null && !"".equals(cpsb)){
			query.setParameter("cpsb", cpsb);
		}
        if(rlzl!=null && !"".equals(rlzl)){
			query.setParameter("rlzl", rlzl);
		}
        if(qymc!=null && !"".equals(qymc)){
			query.setParameter("qymc",  "%"+qymc+"%");
		}
        if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
            query.setParameter("startTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
            query.setParameter("endTime", page.getEndTime());
		}
        Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}
	/**
	 * 通过型号获取审核列表
	 * @param qyid 
	 * @param cpmc 
	 * */
	@SuppressWarnings("unchecked")
	public List<Map<String, Object>> findxhPage(PageParam page,String xh, String qyid, String pc, String cpsb, String rlzl, String qymc) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select t.* , rownum rn from (select * from ");
		sql.append(" ( ");
		sql.append(" select a.燃料种类 rlzl , a.企业ID as qy_id, a.中文品牌  as cppp, a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from RETRIEVAL.clcp_zk a ");
		sql.append(" where a.车辆型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称  like :qymc");
		}
		sql.append(" union all ");
		sql.append(" select  a.燃料种类 rlzl , a.企业ID as qy_id, a.产品商标 as cppp,a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from RETRIEVAL.chpdpk_zk a ");
		sql.append(" where a.底盘型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称  like :qymc");
		}
		/*sql.append(" union all ");
		sql.append(" select  a.燃料种类 rlzl , a.企业ID as qy_id, a.中文品牌  as cppp, a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from NERDS.clcp_zk_new a ");
		sql.append(" where a.车辆型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		sql.append(" union all ");
		sql.append(" select  a.燃料种类 rlzl , a.企业ID as qy_id, a.产品商标 as cppp,a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from NERDS.chpdpk_zk_new a ");
		sql.append(" where a.底盘型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}*/
		sql.append(" ) z where 1=1 ");
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND ggsxrq >=:startTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND ggsxrq <=:endTime ");
		}
		sql.append(" order by to_number(z.pc) desc, z.cph ) t");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setParameter("xh", xh);
        if(qyid!=null && !"".equals(qyid)){
            query.setParameter("qyid", qyid);
        }
        if(pc!=null && !"".equals(pc)){
            query.setParameter("pc", pc);
        }
        if(cpsb!=null && !"".equals(cpsb)){
			query.setParameter("cpsb", cpsb);
		}
        if(rlzl!=null && !"".equals(rlzl)){
			query.setParameter("rlzl", rlzl);
		}
        if(qymc!=null && !"".equals(qymc)){
			query.setParameter("qymc",  "%"+qymc+"%");
		}
        if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
            query.setParameter("startTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
            query.setParameter("endTime", page.getEndTime());
		}
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
		return list;
	}
	public Long findxhPageCount(PageParam page,String xh, String qyid, String pc, String cpsb, String rlzl, String qymc) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select count(*) from ");
		sql.append(" ( ");
		sql.append(" select  a.燃料种类 rlzl , a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from RETRIEVAL.clcp_zk a ");
		sql.append(" where a.车辆型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称  like :qymc");
		}
		sql.append(" union all ");
		sql.append(" select  a.燃料种类 rlzl , a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from RETRIEVAL.chpdpk_zk a ");
		sql.append(" where a.底盘型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标  =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称  like :qymc");
		}
		/*sql.append(" union all ");
		sql.append(" select  a.燃料种类 rlzl , a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from NERDS.clcp_zk_new a ");
		sql.append(" where a.车辆型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		sql.append(" union all ");
		sql.append(" select  a.燃料种类 rlzl , a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from NERDS.chpdpk_zk_new a ");
		sql.append(" where a.底盘型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标  =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}*/
		sql.append(" ) z where 1=1");
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND ggsxrq >=:startTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND ggsxrq <=:endTime ");
		}
		sql.append(" order by to_number(z.pc) desc, z.cph ");
		Query query = entityManager.createNativeQuery(sql.toString());
		//query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		query.setParameter("xh", xh);
        if(qyid!=null && !"".equals(qyid)){
            query.setParameter("qyid", qyid);
        }
        if(pc!=null && !"".equals(pc)){
            query.setParameter("pc", pc);
        }
        if(cpsb!=null && !"".equals(cpsb)){
			query.setParameter("cpsb", cpsb);
		}
        if(rlzl!=null && !"".equals(rlzl)){
			query.setParameter("rlzl", rlzl);
		}
        if(qymc!=null && !"".equals(qymc)){
			query.setParameter("qymc",  "%"+qymc+"%");
		}
        if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
            query.setParameter("startTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
            query.setParameter("endTime", page.getEndTime());
		}
        Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}
	
	/**
	 * 通过名称获取审核列表
	 * @param qyid 
	 * @param cpmc 
	 * */
	@SuppressWarnings("unchecked")
	public List<Map<String, Object>> findnamePage(PageParam page,String qymc, String qyid, String pc, String cpsb, String rlzl, String cpmc) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select t.* , rownum rn from (select * from ");
		sql.append(" ( ");
		sql.append(" select  a.燃料种类 rlzl , a.企业ID as qy_id, a.中文品牌  as cppp,a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.clcp_zk a ");
		sql.append(" where 1=1 ");
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称 like :qymc");
		}
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(cpmc!=null && !"".equals(cpmc)){
			sql.append(" and a.车辆名称  like :cpmc");
		}
		sql.append(" union ");
		sql.append(" select  a.燃料种类 rlzl , a.企业ID as qy_id, a.产品商标 as cppp,a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.chpdpk_zk a ");
		sql.append(" where 1=1 ");
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称 like :qymc");
		}
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标  =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(cpmc!=null && !"".equals(cpmc)){
			sql.append(" and a.产品名称  like :cpmc");
		}
		/*sql.append(" union ");
		sql.append(" select  a.燃料种类 rlzl , a.企业ID as qy_id, a.中文品牌  as cppp,a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.clcp_zk_new  a ");
		sql.append(" where a.企业名称 like :name ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		sql.append(" union ");
		sql.append(" select  a.燃料种类 rlzl , a.企业ID as qy_id, a.产品商标 as cppp,a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.chpdpk_zk_new a ");
		sql.append(" where a.企业名称 like :name ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标  =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}*/
		sql.append(" ) z where 1=1 ");
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND ggsxrq >=:startTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND ggsxrq <=:endTime ");
		}
		sql.append(" order by to_number(z.pc) desc, z.cph) t ");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);

        if(qymc!=null && !"".equals(qymc)){			 
        	query.setParameter("qymc", "%"+qymc+"%"); 
		}
        if(qyid!=null && !"".equals(qyid)){
            query.setParameter("qyid", qyid);
        }
        if(pc!=null && !"".equals(pc)){
            query.setParameter("pc", pc);
        }
        if(cpsb!=null && !"".equals(cpsb)){
			query.setParameter("cpsb", cpsb);
		}
        if(rlzl!=null && !"".equals(rlzl)){
			query.setParameter("rlzl", rlzl);
		}
        if(cpmc!=null && !"".equals(cpmc)){
			query.setParameter("cpmc",  "%"+cpmc+"%");
		}
        if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
            query.setParameter("startTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
            query.setParameter("endTime", page.getEndTime());
		}
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
		return list;
	}
	public Long findnamePageCount(PageParam page, String qymc, String qyid, String pc, String cpsb, String rlzl, String cpmc) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select count(*) from ");
		sql.append(" ( ");
		sql.append(" select a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.clcp_zk a ");
		sql.append(" where 1=1 ");
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称 like :qymc");
		}
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(cpmc!=null && !"".equals(cpmc)){
			sql.append(" and a.车辆名称 like :cpmc");
		}
		sql.append(" union ");
		sql.append(" select a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.chpdpk_zk a ");
		sql.append(" where 1=1 ");
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称 like :qymc");
		}
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标  =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(cpmc!=null && !"".equals(cpmc)){
			sql.append(" and a.产品名称 like :cpmc");
		}
		/*sql.append(" union ");
		sql.append(" select a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.clcp_zk_new a ");
		sql.append(" where a.企业名称 like :name ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		sql.append(" union ");
		sql.append(" select a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.chpdpk_zk_new a ");
		sql.append(" where a.企业名称 like :name ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}*/
		sql.append(" ) z where 1=1");
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND ggsxrq >=:startTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND ggsxrq <=:endTime ");
		}
		sql.append(" order by to_number(z.pc) desc, z.cph ");
		Query query = entityManager.createNativeQuery(sql.toString());
		//query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		if(qymc!=null && !"".equals(qymc)){			 
        	query.setParameter("qymc", "%"+qymc+"%"); 
		}
		if(qyid!=null && !"".equals(qyid)){
			query.setParameter("qyid", qyid);
		}
		if(pc!=null && !"".equals(pc)){
			query.setParameter("pc", pc);
		}
		if(cpsb!=null && !"".equals(cpsb)){
			query.setParameter("cpsb", cpsb);
		}
		if(rlzl!=null && !"".equals(rlzl)){
			query.setParameter("rlzl", rlzl);
		}
		if(cpmc!=null && !"".equals(cpmc)){
			query.setParameter("cpmc",  "%"+cpmc+"%");
		}
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			query.setParameter("startTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			query.setParameter("endTime", page.getEndTime());
		}
        Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}
	


	@SuppressWarnings("unchecked")
	public Map<String, Object> paramdetail(String cph) {
		Map<String, Object> product = new HashMap<String, Object>();
		StringBuffer sql = new StringBuffer();
		sql.append("  SELECT A .底盘ID1 || NVL2 (A .底盘ID2,',' || A .底盘ID2,NULL) || NVL2 (A .底盘ID3,',' || A .底盘ID3,NULL) ");
		sql.append("  || NVL2 (A .底盘ID4,',' || A .底盘ID4,NULL) AS 底盘ID,");
		sql.append("  A.CPNO as 产品ID,A.产品号,A.产品类别,A.企业ID,A.产品型号,A.企业名称,A.生产地址,A.车辆型号,A.车辆名称,");
		sql.append("  A.车辆名称 as 产品名称,A.中文品牌,A.英文品牌,A.前轮距,A.后轮距,A.M发动机 as 发动机型号,A.M发企业 as 发动机企业,");
		sql.append("  A.M排量 as 发动机排量,A.M功率 as 发动机功率,A.M发商标 as 发动机商标,A.识别代号 as 识别代号序列,A.转向形式,A.燃料种类,");
		sql.append("  A.依据标准 as 排放标准,A.长,A.宽,A.高,A.货厢长 as 货箱内部长度,A.货厢宽 as 货厢内部宽,A.货厢高 as 货厢内部高,A.轴数,A.轴距,");
		sql.append("  A.弹簧片数 as 钢板弹簧片数,A.轮胎数,A.轮胎规格,A.总质量,A.额定质量 as 核定载质量,A.整备质量,A.载质量,A.半挂鞍座, A.接近离去角 ,");
		sql.append("  A.额定载客 as 核定载客,A.前排乘客 as 驾驶室前排载客,A.前悬后悬,A.最高车速 as 最高设计车速,");
		sql.append("  A.底企型1||A.底企型2||A.底企型3||A.底企型4 as 底盘企业及底盘型号,A.轴荷,A.油耗,A.免检,A.防抱死系统,");
		sql.append("  A.标识型号,A.标识商标,A.标识企业,A.批次,A.发布日期 as 公告发布日期, A.生效日期 as 公告生效日期,A.其它 as 备注,");
		sql.append("  A.TZXSRQ as 停止销售日期,");
		sql.append("  B.CXPC as 撤销公告批次,");
		sql.append("  B.CXSJ as 撤销公告发布日期");
		sql.append("  FROM  ");
		sql.append("  RETRIEVAL.CLCP_ZK A  ");
		sql.append("  LEFT JOIN GGCAIN06.CLCP_DELETE_SUSPEND B ON A .CPNO = B.CPNO  ");
		sql.append("  WHERE A .产品号 = ?");
		Query query = entityManager.createNativeQuery(sql.toString());
		query.setParameter(1, cph);
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();

		if(list.isEmpty()){
            product.put("err", "ERR");
		    return product;
        }
		list.get(0).put("制造国",null);
		list.get(0).put("车辆类型",null);
		list.get(0).put("准牵引总质量",null);
		list.get(0).put("驾驶室后排载客",null);
		list.get(0).put("车辆结构代码",null);
		list.get(0).put("免检有效期止",null);
		list.get(0).put("停止生产日期",null);
		//list.get(0).put("停止销售日期",null);
//		list.get(0).put("公告发布日期",null);
//		list.get(0).put("公告生效日期",null);
		list.get(0).put("更新日期",null);
		list.get(0).put("数据状态",null);
		product.put("paramMap", list.get(0));

        return product;
	}

	/**
	 * 获取图片参数
	 * @param cph 产品号
	 * @param type 产品类型
	 * @return
	 */
	@SuppressWarnings("unused")
	public Map<String, Object> getParamPic(String cph, String type) {
		List<Map<String, String>> picParamList = new ArrayList<Map<String, String>>();
		String picSql = "select  \"照片\" as 右部照片 ,\"照片2\" as 选装照片1,\"照片3\" as 选装照片2 ,\"照片4\" as 选装照片3,\"后部照片\",\"侧后防护\" from RETRIEVAL.clcp_zk a where \"产品号\" = ?";
		if("2".equals(type)){
			picSql = "select chfhzp,ybzp as 右部照片,hbzp as 后部照片,xzzp2 as 选装部件2,xzzp3 as 选装部件3,xzzp1 as 选装部件1 from RETRIEVAL.chpdpk_zk where 产品号 = ?";
		}
		Query picQuery = entityManager.createNativeQuery(picSql);
		picQuery.setParameter(1,cph);
		picQuery.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		@SuppressWarnings("unchecked")
		List<Map<String, Object>> picResult = picQuery.getResultList();
		if(picResult.get(0).containsKey("chfhzp")){
			picResult.get(0).put("侧后下部防护装置的组合照片",picResult.get(0).get("chfhzp"));
			picResult.get(0).remove("chfhzp");
		}else if(picResult.get(0).containsKey("侧后防护")){
			picResult.get(0).put("侧后下部防护装置的组合照片",picResult.get(0).get("侧后防护"));
			picResult.get(0).remove("侧后防护");
		}
		Map<String, Object> picMap = new LinkedHashMap<>();
		for(String key: picResult.get(0).keySet()){
			// 如果图片存在放到结果集中
			String zp = picResult.get(0).get(key)==null?"":picResult.get(0).get(key).toString();
			if(StringUtils.isNotEmpty(zp)) {
                String url = ifPicExists(zp);
                picMap.put(key, url);
            }
		}
		return picMap;
	}

	/**
	 * 查询地盘参数信息
	 * @param cph
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public Map<String,Object> paramdetailDp(String cph) {
		final Map<String, Object> product = new HashMap<String, Object>();
		StringBuffer sql = new StringBuffer();
		sql.append("   SELECT  A.企业ID,A.产品号,A.DPID as 底盘ID,A.企业名称,A.生产地址,A.底盘型号,A.底盘类别 as 产品型号,  ");
		sql.append("   A.产品名称,A.产品商标,A.长,A.宽,A.高,A.燃料种类,A.依据标准,A.前悬后悬,A.转向形式,A.轴数,A.轴距,A.弹簧片数,  ");
		sql.append("   A.轮胎数,A.轮胎规格,A.前轮距,A.后轮距,A.总质量,A.整备质量,A.挂车质量,A.M发动机 as 发动机型号,  ");
		sql.append("   A.M发企业 as 发动机企业,A.M排量 as 排量,A.M功率 as 功率,A.识别代号,A.其它 as 备注,A.最高车速 as 最高设计车速,  ");
		sql.append("   A.轴荷,A.防抱死系统 as 防抱死制动系统,A.半挂鞍座 ,A.批次,A.发布日期 as 公告发布日期, A.生效日期 as 公告生效日期,  ");
		sql.append("   A.TZXSRQ as 停止销售日期,  ");
		sql.append("   B.CXPC as 撤销公告批次,  B.CXSJ as 撤销公告发布日期    ");
		sql.append("   FROM RETRIEVAL.chpdpk_zk A  ");
		sql.append("   LEFT JOIN GGCAIN06.dpk B ON A .dpid = B.dpid  ");
		sql.append("   WHERE A .产品号 = ? ");
		Query query = entityManager.createNativeQuery(sql.toString());
		query.setParameter(1,cph);
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		if(list.isEmpty()){
			product.put("err", "ERR");
			return product;
		}
		list.get(0).put("[挂车质量/准牵引总质量]", list.get(0).get("挂车质量"));
		list.get(0).remove("挂车质量");
		list.get(0).put("半挂车鞍座最大允许总质量", list.get(0).get("半挂鞍座"));
		list.get(0).remove("半挂鞍座");
		list.get(0).put("前排乘客", "");
		list.get(0).put("后排乘客", "");
		list.get(0).put("油耗", "");
		list.get(0).put("产品更新标记", "");
		list.get(0).put("停止生产日期", "");
//		list.get(0).put("停止销售日期", "");
//		list.get(0).put("公告发布日期", "");
//		list.get(0).put("公告生效日期", "");
		list.get(0).put("更新日期", "");
		list.get(0).put("数据状态", "已同步");
		product.put("paramMap", list.get(0));
		return product;
	}

	/**
	 * 验证图片是否存在,如果存在返回其路径
	 *
	 * @param filename
	 * @return
	 */
	private String ifPicExists(String filename) {

		StringBuffer filePath = new StringBuffer().append("/3310b/ggpic/mlsw/").append(filename);
		String filePath1 = filePath.toString() + ".jpg";
		String filePath2 = filePath.toString() + ".JPG";
		File file1 = new File(filePath1);
		File file2 = new File(filePath2);
		StringBuffer url = new StringBuffer().append("http://123.127.164.35:18082/zjpic/");
		if (!checkFileExists || file1.exists()) {
			url.append(filename).append(".jpg");
			return url.toString();
		} else if (!checkFileExists || file2.exists()) {
			url.append(filename).append(".JPG");
			return url.toString();
		}
		return null;
	}
	private boolean checkFileExists = false;

	public boolean isCheckFileExists() {
		return checkFileExists;
	}
	public void setCheckFileExists(boolean checkFileExists) {
		this.checkFileExists = checkFileExists;
	}


	@SuppressWarnings("unchecked")
	public Map<String, Object> paramcount() {
		Map<String, Object> map=new HashMap<String, Object>();
		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT (select count(1) from retrieval.clcp_zk ) +(select count(1) from retrieval.chpdpk_zk) as allcount, ");
		sql.append(" (select count(1) from retrieval.ret_users where enabled = '1') as qycount FROM dual ");
		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		if(list.isEmpty()) return map;
		map=list.get(0);
		return map;
	}


	public String getdpxh(String dpid) {
		StringBuilder sql = new StringBuilder();
		sql.append("SELECT 产品号  FROM RETRIEVAL.chpdpk_zk  WHERE dpid = ?  ORDER BY 批次 desc ");
		Query query = entityManager.createNativeQuery(sql.toString());
		query.setParameter(1,dpid);
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		Map<String, Object> map=(Map<String, Object>) query.getResultList().get(0);
		String dpxh=map.get("产品号")!=null?map.get("产品号").toString():"";
		return dpxh;
	}


	/**
	 * 获取高级查询的sql和参数
	 * 
	 * @param spp
	 * @return
	 */
	private Map<String, Object[]> getSqlAndParams(SearchProductParams spp) {
		StringBuffer zcbf = new StringBuffer();
		StringBuffer dpbf = new StringBuffer();
		//新加
		StringBuffer zcbfAdd = new StringBuffer();
		
		List<Object> zcParamList = new ArrayList<Object>();
		List<Object> dpParamList = new ArrayList<Object>();
		//新加
		List<Object> zcParamListAdd = new ArrayList<Object>();
		
		StringBuffer bf = new StringBuffer();
		Object[] params = null;
		Map<String, Object[]> m = new HashMap<String, Object[]>();

		bf.append("select 企业名称,产品号,产品商标,批次,产品型号,产品名称,生产地址,轴数,轴距,总质量,轮胎规格,M发动机,前轮距,后轮距,燃料种类,发布日期,生效日期,type  from (");
		zcbf.append("select 企业名称,产品号,产品商标,批次,车辆型号 as 产品型号,车辆名称 as 产品名称,生产地址,轴数,轴距,总质量,轮胎规格,M发动机,前轮距,后轮距,燃料种类,发布日期,生效日期,1 as type  from retrieval.clcp_zk where 1=1 ");
		dpbf.append("select 企业名称,产品号,产品商标,批次,底盘型号 as 产品型号,产品名称,生产地址,轴数,轴距,总质量,轮胎规格,M发动机,前轮距,后轮距,燃料种类,发布日期,生效日期,2 as type  from retrieval.chpdpk_zk  where 1=1 ");
		

		if (null != spp && spp.getQymc() != null && !"".equals(spp.getQymc())) {
			zcbf.append(" and 企业名称 like ?");
			zcParamList.add("%" + spp.getQymc().trim() + "%");

			dpbf.append(" and 企业名称 like ?");
			dpParamList.add("%" + spp.getQymc().trim() + "%");
		}

		if (null != spp && spp.getCph() != null && !"".equals(spp.getCph())) {
			zcbf.append(" and 产品号 like ?");
			zcParamList.add("%" + spp.getCph().trim() + "%");

			dpbf.append(" and 产品号 like ?");
			dpParamList.add("%" + spp.getCph().trim() + "%");
		}

		if (null != spp && spp.getCpsb() != null && !"".equals(spp.getCpsb())) {
			zcbf.append(" and 产品商标 like ?");
			zcParamList.add("%" + spp.getCpsb().trim() + "%");

			dpbf.append(" and 产品商标 like ?");
			dpParamList.add("%" + spp.getCpsb().trim() + "%");
		}

		//新加
		boolean flag = false;
		if (null != spp && spp.getCpsb() != null && !"".equals(spp.getCpsb())&& !"".equals(spp.getPfjd())&& spp.getPfjd() != null ) {
			
			//新加
			zcbfAdd.append("select 企业名称,产品号,产品商标,批次,车辆型号 as 产品型号,车辆名称 as 产品名称,生产地址,轴数,轴距,总质量,轮胎规格,M发动机,前轮距,后轮距,燃料种类,发布日期,生效日期,1 as type  from retrieval.clcp_zk where 1=1 ");
			
			zcbfAdd.append(" and 底盘ID1 IN ( SELECT dpid FROM retrieval.chpdpk_zk WHERE 依据标准 LIKE ? ) AND 产品商标 LIKE ? ");
			zcParamListAdd.add("%" + spp.getPfjd().trim() + "%");
			zcParamListAdd.add("%" + spp.getCpsb().trim() + "%");
		    flag = true;
		}
		
		//新加 ======begin 
		if (flag && null != spp && spp.getQymc() != null && !"".equals(spp.getQymc())) {
			zcbfAdd.append(" and 企业名称 like ?");
			zcParamListAdd.add("%" + spp.getQymc().trim() + "%");
		}

		if (flag && null != spp && spp.getCph() != null && !"".equals(spp.getCph())) {
			zcbfAdd.append(" and 产品号 like ?");
			zcParamListAdd.add("%" + spp.getCph().trim() + "%");
		}
		//新加 ======end 
		
		if (null != spp && spp.getPc() != null && !"".equals(spp.getPc())) {
			zcbf.append(" and 批次 = ?");
			zcParamList.add(spp.getPc());

			dpbf.append(" and 批次 = ?");
			dpParamList.add(spp.getPc());
		}
		
		//新增
		if (flag && null != spp && spp.getPc() != null && !"".equals(spp.getPc())) {
		zcbfAdd.append(" and 批次 = ?");
		zcParamListAdd.add(spp.getPc());
		}
		
		
//		if (null != spp && spp.getPfjd() != null && !"".equals(spp.getPfjd())) {
//			zcbf.append(" and 排放水平 = ?");
//			zcParamList.add(spp.getPfjd());
//
//			dpbf.append(" and 排放水平 = ?");
//			dpParamList.add(spp.getPfjd());
//		}
		
		if (null != spp && spp.getPfjd() != null && !"".equals(spp.getPfjd())) {
			zcbf.append(" and 依据标准 like ?");
			zcParamList.add("%" + spp.getPfjd().trim() + "%");
			dpbf.append(" and 依据标准 like ?");
			dpParamList.add("%" + spp.getPfjd().trim() + "%");
		   }
		
		
		if (null != spp && spp.getDpxh() != null && !"".equals(spp.getDpxh())) {
			zcbf.append(" and 底企型1 like ?");
			zcParamList.add("%" + spp.getDpxh().trim() + "%");
			dpbf.append(" and 底盘型号 like ?");
			dpParamList.add("%" + spp.getDpxh().trim() + "%");
		   }

		//新增
		if (flag && null != spp && spp.getDpxh() != null && !"".equals(spp.getDpxh())) {
			zcbfAdd.append(" and 底企型1 like ?");
			zcParamListAdd.add("%" + spp.getDpxh().trim() + "%");
		   }
	
		if (null != spp && spp.getCpxh() != null && !"".equals(spp.getCpxh())) {
			zcbf.append(" and 车辆型号 like ?");
			zcParamList.add("%" + spp.getCpxh().trim() + "%");

			dpbf.append(" and 底盘型号 like ?");
			dpParamList.add("%" + spp.getCpxh().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getCpxh() != null && !"".equals(spp.getCpxh())) {
			zcbfAdd.append(" and 车辆型号 like ?");
			zcParamListAdd.add("%" + spp.getCpxh().trim() + "%");
		}
		
		if (null != spp && spp.getCpmc() != null && !"".equals(spp.getCpmc())) {
			zcbf.append(" and 车辆名称 like ?");
			zcParamList.add("%" + spp.getCpmc().trim() + "%");

			dpbf.append(" and 产品名称 like ?");
			dpParamList.add("%" + spp.getCpmc().trim() + "%");
		}
		
		//新增
		if (flag && null != spp && spp.getCpmc() != null && !"".equals(spp.getCpmc())) {
			zcbfAdd.append(" and 车辆名称 like ?");
			zcParamListAdd.add("%" + spp.getCpmc().trim() + "%");
		}


		if (null != spp && spp.getScdz() != null && !"".equals(spp.getScdz())) {
			zcbf.append(" and 生产地址 like ?");
			zcParamList.add("%" + spp.getScdz().trim() + "%");

			dpbf.append(" and 生产地址 like ?");
			dpParamList.add("%" + spp.getScdz().trim() + "%");
		}
		
		//新增
		if (flag && null != spp && spp.getScdz() != null && !"".equals(spp.getScdz())) {
			zcbfAdd.append(" and 生产地址 like ?");
			zcParamListAdd.add("%" + spp.getScdz().trim() + "%");
		}
		
		

		if (null != spp && spp.getZs() != null && !"".equals(spp.getZs())) {
			zcbf.append(" and 轴数 like ?");
			zcParamList.add("%" + spp.getZs().trim() + "%");

			dpbf.append(" and 轴数 like ?");
			dpParamList.add("%" + spp.getZs().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getZs() != null && !"".equals(spp.getZs())) {
			zcbfAdd.append(" and 轴数 like ?");
			zcParamListAdd.add("%" + spp.getZs().trim() + "%");
		}
		
		
		if (null != spp && spp.getZj() != null && !"".equals(spp.getZj())) {
			zcbf.append(" and 轴距 like ?");
			zcParamList.add("%" + spp.getZj().trim() + "%");

			dpbf.append(" and 轴距 like ?");
			dpParamList.add("%" + spp.getZj().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getZj() != null && !"".equals(spp.getZj())) {
			zcbfAdd.append(" and 轴距 like ?");
			zcParamListAdd.add("%" + spp.getZj().trim() + "%");
		}
		

		if (null != spp && spp.getLts() != null && !"".equals(spp.getLts())) {
			zcbf.append(" and 轮胎数 like ?");
			zcParamList.add("%" + spp.getLts().trim() + "%");

			dpbf.append(" and 轮胎数 like ?");
			dpParamList.add("%" + spp.getLts().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getLts() != null && !"".equals(spp.getLts())) {
			zcbfAdd.append(" and 轮胎数 like ?");
			zcParamListAdd.add("%" + spp.getLts().trim() + "%");
		}
		
		
		if (null != spp && spp.getFdjxh() != null && !"".equals(spp.getFdjxh())) {
			zcbf.append(" and M发动机 like ?");
			zcParamList.add("%" + spp.getFdjxh().trim() + "%");

			dpbf.append(" and M发动机 like ?");
			dpParamList.add("%" + spp.getFdjxh().trim() + "%");
		}
		
		//新增
		if (flag && null != spp && spp.getFdjxh() != null && !"".equals(spp.getFdjxh())) {
			zcbfAdd.append(" and M发动机 like ?");
			zcParamListAdd.add("%" + spp.getFdjxh().trim() + "%");
		}

		if (null != spp && spp.getQlj() != null && !"".equals(spp.getQlj())) {
			zcbf.append(" and 前轮距 like ?");
			zcParamList.add("%" + spp.getQlj().trim() + "%");

			dpbf.append(" and 前轮距 like ?");
			dpParamList.add("%" + spp.getQlj().trim() + "%");
		}
		
		//新增
		if (flag && null != spp && spp.getQlj() != null && !"".equals(spp.getQlj())) {
			zcbfAdd.append(" and 前轮距 like ?");
			zcParamListAdd.add("%" + spp.getQlj().trim() + "%");
		}
		

		if (null != spp && spp.getHlj() != null && !"".equals(spp.getHlj())) {
			zcbf.append(" and 后轮距 like ?");
			zcParamList.add("%" + spp.getHlj().trim() + "%");

			dpbf.append(" and 后轮距 like ?");
			dpParamList.add("%" + spp.getHlj().trim() + "%");
		}

		//新加 
		if (flag && null != spp && spp.getHlj() != null && !"".equals(spp.getHlj())) {
			zcbfAdd.append(" and 后轮距 like ?");
			zcParamListAdd.add("%" + spp.getHlj().trim() + "%");
		}
		
		
		if (null != spp && spp.getRlzl() != null && !"".equals(spp.getRlzl())) {
			zcbf.append(" and 燃料种类 like ?");
			zcParamList.add("%" + spp.getRlzl().trim() + "%");

			dpbf.append(" and 燃料种类 like ?");
			dpParamList.add("%" + spp.getRlzl().trim() + "%");
		}
		
		//新加 
		if (flag && null != spp && spp.getRlzl() != null && !"".equals(spp.getRlzl())) {
			zcbfAdd.append(" and 燃料种类 like ?");
			zcParamListAdd.add("%" + spp.getRlzl().trim() + "%");
		}

		// 长前
		if (null != spp && spp.getWxchangq() != null && !"".equals(spp.getWxchangq())) {
			zcbf.append(" and chang_n >= ?");
			zcParamList.add(spp.getWxchangq());

			dpbf.append(" and chang_n >= ?");
			dpParamList.add(spp.getWxchangq());
		}
		
		//新加     长前
		if (flag && null != spp && spp.getWxchangq() != null && !"".equals(spp.getWxchangq())) {
			zcbfAdd.append(" and chang_n >= ?");
			zcParamListAdd.add(spp.getWxchangq());
		}
		

		// 长后
		if (null != spp && spp.getWxchangh() != null && !"".equals(spp.getWxchangh())) {
			zcbf.append(" and chang_n <= ?");
			zcParamList.add(spp.getWxchangh());

			dpbf.append(" and chang_n <= ?");
			dpParamList.add(spp.getWxchangh());
		}
		
		// 新加  长后
		if (flag && null != spp && spp.getWxchangh() != null && !"".equals(spp.getWxchangh())) {
			zcbfAdd.append(" and chang_n <= ?");
			zcParamListAdd.add(spp.getWxchangh());
		}
		

		// 宽前
		if (null != spp && spp.getWxkuanq() != null && !"".equals(spp.getWxkuanq())) {
			zcbf.append(" and kuan_n >= ?");
			zcParamList.add(spp.getWxkuanq());

			dpbf.append(" and kuan_n >= ?");
			dpParamList.add(spp.getWxkuanq());
		}
		
		
		// 新加   宽前
		if (flag && null != spp && spp.getWxkuanq() != null && !"".equals(spp.getWxkuanq())) {
			zcbfAdd.append(" and kuan_n >= ?");
			zcParamListAdd.add(spp.getWxkuanq());
		}
		

		// 宽后
		if (null != spp && spp.getWxkuanh() != null && !"".equals(spp.getWxkuanh())) {
			zcbf.append(" and kuan_n <= ?");
			zcParamList.add(spp.getWxkuanh());

			dpbf.append(" and kuan_n <= ?");
			dpParamList.add(spp.getWxkuanh());
		}
		
		
		//新加  宽后
		if (flag && null != spp && spp.getWxkuanh() != null && !"".equals(spp.getWxkuanh())) {
			zcbfAdd.append(" and kuan_n <= ?");
			zcParamListAdd.add(spp.getWxkuanh());
		}
		

		// 高前
		if (null != spp && spp.getWxgaoq() != null && !"".equals(spp.getWxgaoq())) {
			zcbf.append(" and gao_n >= ?");
			zcParamList.add(spp.getWxgaoq());

			dpbf.append(" and gao_n >= ?");
			dpParamList.add(spp.getWxgaoq());
		}
		
		
		// 新加  高前
		if (flag && null != spp && spp.getWxgaoq() != null && !"".equals(spp.getWxgaoq())) {
			zcbfAdd.append(" and gao_n >= ?");
			zcParamListAdd.add(spp.getWxgaoq());
		}
		

		// 高后
		if (null != spp && spp.getWxgaoh() != null && !"".equals(spp.getWxgaoh())) {
			zcbf.append(" and gao_n <= ?");
			zcParamList.add(spp.getWxgaoh());

			dpbf.append(" and gao_n <= ?");
			dpParamList.add(spp.getWxgaoh());
		}
		
		//新加    高后
		if (flag && null != spp && spp.getWxgaoh() != null && !"".equals(spp.getWxgaoh())) {
			zcbfAdd.append(" and gao_n <= ?");
			zcParamListAdd.add(spp.getWxgaoh());
		}
		
		

		// 总质量前
		if (null != spp && spp.getZzlq() != null && !"".equals(spp.getZzlq())) {
			//zcbf.append(" and zzl_n >= ?");
			zcbf.append(" and 总质量 >= ?");
			
			zcParamList.add(spp.getZzlq());

			//dpbf.append(" and zzl_n >= ?");
			dpbf.append(" and 总质量 >= ?");
			
			dpParamList.add(spp.getZzlq());
		}

		
		// 新加 总质量前
		if (flag  && null != spp && spp.getZzlq() != null && !"".equals(spp.getZzlq())) {
			zcbfAdd.append(" and 总质量 >= ?");
			zcParamListAdd.add(spp.getZzlq());
		}
		
		
		// 总质量后
		if (null != spp && spp.getZzlh() != null && !"".equals(spp.getZzlh())) {
//			zcbf.append(" and zzl_n <= ?");
			zcbf.append(" and 总质量 <= ?");
			zcParamList.add(spp.getZzlh());

//			dpbf.append(" and zzl_n <= ?");
			dpbf.append(" and 总质量 <= ?");

			dpParamList.add(spp.getZzlh());
		}
		
		// 新增  总质量后
		if (flag && null != spp && spp.getZzlh() != null && !"".equals(spp.getZzlh())) {
			zcbfAdd.append(" and 总质量 <= ?");
			zcParamListAdd.add(spp.getZzlh());
		}
		
		
		

		// 额定质量前
		if (null != spp && spp.getEdzlq() != null && !"".equals(spp.getEdzlq())) {
			zcbf.append(" and edzl_n >= ?");
			zcParamList.add(spp.getEdzlq());

			dpbf.append(" and edzl_n >= ?");
			dpParamList.add(spp.getEdzlq());
		}

		// 新增  额定质量前
		if (flag && null != spp && spp.getEdzlq() != null && !"".equals(spp.getEdzlq())) {
			zcbfAdd.append(" and edzl_n >= ?");
			zcParamListAdd.add(spp.getEdzlq());
		}
		
		
		
		// 额定质量后
		if (null != spp && spp.getEdzlh() != null && !"".equals(spp.getEdzlh())) {
			zcbf.append(" and zzl_n <= ?");
			zcParamList.add(spp.getEdzlh());

			dpbf.append(" and zzl_n <= ?");
			dpParamList.add(spp.getEdzlh());
		}
		
		
		//新增  额定质量后
		if (flag && null != spp && spp.getEdzlh() != null && !"".equals(spp.getEdzlh())) {
			zcbfAdd.append(" and zzl_n <= ?");
			zcParamListAdd.add(spp.getEdzlh());
		}
		

		// 整备质量前
		if (null != spp && spp.getZbzlq() != null && !"".equals(spp.getZbzlq())) {
			zcbf.append(" and zbzl_n >= ?");
			zcParamList.add(spp.getZbzlq());

			dpbf.append(" and zbzl_n >= ?");
			dpParamList.add(spp.getZbzlq());
		}
		
		
		//新增   整备质量前
		if (flag && null != spp && spp.getZbzlq() != null && !"".equals(spp.getZbzlq())) {
			zcbfAdd.append(" and zbzl_n >= ?");
			zcParamListAdd.add(spp.getZbzlq());
		}
		
		// 整备质量后
		if (null != spp && spp.getZbzlh() != null && !"".equals(spp.getZbzlh())) {
			zcbf.append(" and zbzl_n <= ?");
			zcParamList.add(spp.getZbzlh());

			dpbf.append(" and zbzl_n <= ?");
			dpParamList.add(spp.getZbzlh());
		}

		// 新增  整备质量后
		if (flag && null != spp && spp.getZbzlh() != null && !"".equals(spp.getZbzlh())) {
			zcbfAdd.append(" and zbzl_n <= ?");
			zcParamListAdd.add(spp.getZbzlh());
		}
		
		
		if ((null != spp && spp.getChang() != null && !"".equals(spp.getChang())) || (null != spp && spp.getKuan() != null && !"".equals(spp.getKuan())) || (null != spp && spp.getGao() != null && !"".equals(spp.getGao()))) {

			zcbf.append("and 货厢长 like ? ");
			zcbf.append("and 货厢宽 like ? ");
			zcbf.append("and 货厢高 like ? ");

			zcParamList.add("%" + spp.getChang().trim() + "%");
			zcParamList.add("%" + spp.getKuan().trim() + "%");
			zcParamList.add("%" + spp.getGao().trim() + "%");

			bf.append(zcbf);
			params = zcParamList.toArray();
		} else {
			bf.append(zcbf);
			bf.append(" union all ");
			bf.append(dpbf);
			//新加
			if(flag){
				bf.append(" union all ");
				bf.append(zcbfAdd);	
			}
			zcParamList.addAll(dpParamList);
			//新加
			if(flag){
				zcParamList.addAll(zcParamListAdd);
			}
			params = zcParamList.toArray();

		}

		m.put(bf.toString(), params);

		return m;
	}


	public List<Map<String, Object>> findMoreList(PageParam page,
			SearchProductParams spp) {
		
		StringBuffer bf = new StringBuffer();

		Object[] params = null;
		final List<Map<String, String>> productLs = new ArrayList<Map<String, String>>();

		Map<String, Object[]> m = this.getSqlAndParams(spp);
		bf.append(" select t.* , rownum rn from ( ");
		bf.append("select 企业名称,产品号,产品商标,批次,产品型号,产品名称,生产地址,轴数,轴距,总质量,轮胎规格,M发动机,前轮距,后轮距,燃料种类,发布日期,substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as 生效日期 ,type,rownum rm from (");

		bf.append(m.keySet().toArray()[0]);
		params = (Object[]) m.values().toArray()[0];

		bf.append(" ) order by 企业名称,批次  desc ) a ");
		bf.append(" ) t");
		
		  Query query = entityManager.createNativeQuery(bf.toString());
	        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
	        for(int i=1 ;i<=params.length;i++){
	        	
	        	
	        	query.setParameter(i, params[i-1]);
	        }
	        query.setFirstResult(page.getOffset());
	        query.setMaxResults(page.getLimit());
	        List<Map<String, Object>> list = query.getResultList();
		return list;
	}

 
	/**
	 * 获取高级查询结果的总数量
	 * 
	 * @param spp
	 * @return
	 */
	public Long findMorePageCount(SearchProductParams spp) {
		StringBuffer bf = new StringBuffer();
		bf.append("select count(产品号) from ( ");
		Map<String, Object[]> m = this.getSqlAndParams(spp);

		bf.append(m.keySet().toArray()[0]);
		bf.append("))");
		Object[] params = (Object[]) m.values().toArray()[0];
		Query query = entityManager.createNativeQuery(bf.toString());
		for(int i=1 ;i<=params.length;i++){
	        query.setParameter(i, params[i-1]);
	    }
		
        Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}


	/**   
	 * @Title: findMapbyUser   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @param name
	 * @param @param xh
	 * @param @param qyid
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @param cpsb 
	 * @param rlzl 
	 * @date 下午6:20:50
	*/   
	public List<Map<String, Object>> findMapbyUser(PageParam page, String name,
			String xh, String pc, String qyid, String rlzl, String cpsb) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select t.* , rownum rn from (select  * from ");
		sql.append(" ( ");
		sql.append(" select a.企业ID as qy_id, a.产品号 as cph, a.cpno, a.车辆名称 as clmc,a.中文品牌  as cppp, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.clcp_zk a ");//车辆产品总库
		sql.append(" where 1=1 ");
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(name!=null && !"".equals(name)){
			sql.append(" and a.车辆名称 like :name");
		}
		if(xh!=null && !"".equals(xh)){
			sql.append(" and a.车辆型号 =:xh");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(qyid!=null && !"".equals(qyid)){

			sql.append(" and (a.企业ID =:qyid  or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid) ) ");
		}
		sql.append(" union ");
		sql.append(" select a.企业ID as qy_id, a.产品号 as cph, a.dpid, a.产品名称 as clmc,a.产品商标 as cppp, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.chpdpk_zk a ");//底盘总库
		sql.append(" where 1=1");
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(name!=null && !"".equals(name)){
			sql.append(" and a.产品名称 like :name");
		}
		if(xh!=null && !"".equals(xh)){
			sql.append(" and a.底盘型号 =:xh");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and (a.企业ID =:qyid  or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid)  )");
		}
		/*sql.append(" union ");
		sql.append(" select a.企业ID as qy_id, a.产品号 as cph, a.cpno, a.车辆名称 as clmc,a.中文品牌  as cppp, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.clcp_zk_NEW a ");//车辆产品总库-2021爬取
		sql.append(" where 1=1 ");
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(name!=null && !"".equals(name)){
			sql.append(" and a.车辆名称 like :name");
		}
		if(xh!=null && !"".equals(xh)){
			sql.append(" and a.车辆型号 =:xh");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		sql.append(" union ");
		sql.append(" select a.企业ID as qy_id, a.产品号 as cph, a.dpid, a.产品名称 as clmc,a.产品商标 as cppp, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.chpdpk_zk_NEW a ");//底盘总库-2021爬取
		sql.append(" where 1=1 ");
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(name!=null && !"".equals(name)){
			sql.append(" and a.产品名称 like :name");
		}
		if(xh!=null && !"".equals(xh)){
			sql.append(" and a.底盘型号 =:xh");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}*/
		sql.append(" ) z WHERE 1=1");			

		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND ggsxrq >=:startTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND ggsxrq <=:endTime ");
		}
		sql.append(" order by to_number(pc) desc) t");
		
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        if(cpsb!=null && !"".equals(cpsb)){
			query.setParameter("cpsb", cpsb);
		}
        if(rlzl!=null && !"".equals(rlzl)){
			query.setParameter("rlzl", rlzl);
		}
		if(name!=null && !"".equals(name)){
			query.setParameter("name", "%"+name+"%");
		}
		if(xh!=null && !"".equals(xh)){
			query.setParameter("xh", xh);
		}
		if(pc!=null && !"".equals(pc)){
			query.setParameter("pc", pc);
		}
        if(qyid!=null && !"".equals(qyid)){
            query.setParameter("qyid", qyid);
        }
        if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
            query.setParameter("startTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
            query.setParameter("endTime", page.getEndTime());
		}
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
		return list;
	}


	/**   
	 * @Title: findMapbyUserCount   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param name
	 * @param @param xh
	 * @param @param qyid
	 * @param @return    设定文件   
	 * @return Long    返回类型   
	 * @author ADC_ZH 
	 * @param cpsb 
	 * @param rlzl 
	 * @date 下午6:20:57 
	*/   
	public Long findMapbyUserCount(PageParam page, String name, String xh, String pc, String qyid, String rlzl, String cpsb) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select count(1) from ");
		sql.append(" ( ");
		sql.append(" select a.产品号 as cph, a.cpno, a.车辆名称 as clmc,a.中文品牌  as cppp, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.clcp_zk a ");//车辆产品总库
		sql.append(" where 1=1 ");
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌=:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(name!=null && !"".equals(name)){
			sql.append(" and a.车辆名称 like :name");
		}
		if(xh!=null && !"".equals(xh)){
			sql.append(" and a.车辆型号 =:xh");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and (a.企业ID =:qyid  or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid)  )");
		}
		sql.append(" union ");
		sql.append(" select a.产品号 as cph, a.dpid, a.产品名称 as clmc,a.产品商标 as cppp, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.chpdpk_zk a ");//底盘总库
		sql.append(" where 1=1");
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(name!=null && !"".equals(name)){
			sql.append(" and a.产品名称 like :name");
		}
		if(xh!=null && !"".equals(xh)){
			sql.append(" and a.底盘型号 =:xh");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and (a.企业ID =:qyid  or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid)  )");
		}
		/*sql.append(" union ");
		sql.append(" select a.产品号 as cph, a.cpno, a.车辆名称 as clmc,a.中文品牌  as cppp, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.clcp_zk_NEW a ");//车辆产品总库-2021爬取
		sql.append(" where 1=1 ");
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌=:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(name!=null && !"".equals(name)){
			sql.append(" and a.车辆名称 like :name");
		}
		if(xh!=null && !"".equals(xh)){
			sql.append(" and a.车辆型号 =:xh");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		sql.append(" union ");
		sql.append(" select a.产品号 as cph, a.dpid, a.产品名称 as clmc,a.产品商标 as cppp, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.chpdpk_zk_NEW a ");//底盘总库-2021爬取
		sql.append(" where 1=1 ");
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(name!=null && !"".equals(name)){
			sql.append(" and a.产品名称 like :name");
		}
		if(xh!=null && !"".equals(xh)){
			sql.append(" and a.底盘型号 =:xh");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}*/
		sql.append(" ) z WHERE 1=1");			

		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND ggsxrq >=:startTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND ggsxrq <=:endTime ");
		}
		
        Query query = entityManager.createNativeQuery(sql.toString());
       // query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        if("undefined".equals(pc)){
        	String max_pc="SELECT TO_CHAR(MAX(TO_NUMBER(\"批次\"))) PC FROM RETRIEVAL.clcp_zk";
        	Query query2 = entityManager.createNativeQuery(max_pc);
        	query2.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        	Map<String, Object> list1 = (Map<String, Object>) query2.getResultList().get(0);
        	pc=list1.get("PC").toString();
        }
        if(cpsb!=null && !"".equals(cpsb)){
			query.setParameter("cpsb", cpsb);
		}
        if(rlzl!=null && !"".equals(rlzl)){
			query.setParameter("rlzl", rlzl);
		}
		if(name!=null && !"".equals(name)){
			query.setParameter("name", "%"+name+"%");
		}
		if(xh!=null && !"".equals(xh)){
			query.setParameter("xh", xh);
		}
		if(pc!=null && !"".equals(pc)){
			query.setParameter("pc", pc);
		}
        if(qyid!=null && !"".equals(qyid)){
            query.setParameter("qyid", qyid);
        }
        if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
            query.setParameter("startTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
            query.setParameter("endTime", page.getEndTime());
		}
        Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}


	/**   
	 * @Title: findBrand   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qyid
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午7:03:41 
	*/   
	public List<Map<String, Object>> findBrand(String qyid) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select  * from ");
		sql.append(" ( ");
		sql.append(" select distinct a.中文品牌 cpsb");
		sql.append(" from RETRIEVAL.clcp_zk a ");//车辆产品总库
		sql.append(" where 1=1 ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		sql.append(" union ");
		sql.append(" select distinct a.产品商标 as cpsb ");
		sql.append(" from RETRIEVAL.chpdpk_zk a ");//底盘总库
		sql.append(" where 1=1"); 
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		/*sql.append(" union ");
		sql.append(" select distinct a.中文品牌  as cpsb ");
		sql.append(" from NERDS.clcp_zk_NEW a ");//车辆产品总库-2021爬取
		sql.append(" where 1=1 "); 
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		sql.append(" union ");
		sql.append(" select distinct a.产品商标 as cpsb ");
		sql.append(" from NERDS.chpdpk_zk_NEW a ");//底盘总库-2021爬取
		sql.append(" where 1=1 "); 
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}*/
		sql.append(" ) z ");
		Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        if(qyid!=null && !"".equals(qyid)){
            query.setParameter("qyid", qyid);
        }
		List<Map<String, Object>> list = query.getResultList();
		return list; 
	}


	/**   
	 * @Title: findFuel   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qyid
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午7:22:45 
	*/   
	public List<Map<String, Object>> findFuel(String qyid) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select  * from ");
		sql.append(" ( ");
		sql.append(" select distinct REPLACE(a.燃料种类, '-', '') rlzl");
		sql.append(" from RETRIEVAL.clcp_zk a ");//车辆产品总库
		sql.append(" where 1=1 ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		sql.append(" union ");
		sql.append(" select distinct REPLACE(a.燃料种类, '-', '') as rlzl ");
		sql.append(" from RETRIEVAL.chpdpk_zk a ");//底盘总库
		sql.append(" where 1=1"); 
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		/*sql.append(" union ");
		sql.append(" select distinct REPLACE(a.燃料种类, '-', '')  as rlzl ");
		sql.append(" from NERDS.clcp_zk_NEW a ");//车辆产品总库-2021爬取
		sql.append(" where 1=1 "); 
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		sql.append(" union ");
		sql.append(" select distinct REPLACE(a.燃料种类, '-', '') as rlzl ");
		sql.append(" from NERDS.chpdpk_zk_NEW a ");//底盘总库-2021爬取
		sql.append(" where 1=1 "); 
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}*/
		sql.append(" ) z where rlzl is not null ");
		Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        if(qyid!=null && !"".equals(qyid)){
            query.setParameter("qyid", qyid);
        }
		List<Map<String, Object>> list = query.getResultList();
		return list; 
	}

	// 339 新增 Start
	/**
	 * 通过型号获取审核列表
	 * @param qyid
	 * */
	@SuppressWarnings("unchecked")
	public List<Map<String, Object>> findxhPage339(PageParam page,String xh, String qyid, String qyid2,String pc) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select t.* , rownum rn from (select * from ");
		sql.append(" ( ");
		sql.append(" select a.企业ID as qyid, a.中文品牌  as cppp, a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from RETRIEVAL.clcp_zk a ");
		sql.append(" where a.车辆型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		sql.append(" union all ");
		sql.append(" select a.企业ID as qyid, a.产品商标 as cppp,a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from RETRIEVAL.chpdpk_zk a ");
		sql.append(" where a.底盘型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		/*sql.append(" union all ");
		sql.append(" select a.企业ID as qyid, a.中文品牌  as cppp, a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from NERDS.clcp_zk_new a ");
		sql.append(" where a.车辆型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}
		sql.append(" union all ");
		sql.append(" select a.企业ID as qyid, a.产品商标 as cppp,a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from NERDS.chpdpk_zk_new a ");
		sql.append(" where a.底盘型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and a.企业ID =:qyid");
		}*/
		sql.append(" ) z ");

		// 339 新增 start
//		sql.append(" WHERE (pc=339 and qyid=:qyid2) or (pc<>339 or pc is null)");
//		sql.append(" WHERE (pc='"+pc+"' and (qyid=:qyid2 or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid) or qyid =(select group_username from RETRIEVAL.ret_users where username=:qyid2))) or (pc<>'"+pc+"' or pc is null)  ");
		sql.append(" WHERE (pc='"+pc+"' and (qyid=:qyid2 or qyid =(select group_username from RETRIEVAL.ret_users where username=:qyid2))) or (pc<>'"+pc+"' or pc is null)  ");

		// 339 新增 end

		sql.append(" order by to_number(z.pc) desc, z.cph ) t  ");

		System.out.println("SQL********************"+sql.toString());

		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		query.setParameter("xh", xh);
		if(qyid!=null && !"".equals(qyid)){
			query.setParameter("qyid", qyid);
		}

		query.setParameter("qyid2", qyid2);

		query.setFirstResult(page.getOffset());
		query.setMaxResults(page.getLimit());
		List<Map<String, Object>> list = query.getResultList();
		return list;
	}
	public Long findxhPageCount339(String xh, String qyid, String qyid2,String pc) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select count(*) from ");
		sql.append(" ( ");
		sql.append(" select a.企业ID as qyid, a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from RETRIEVAL.clcp_zk a ");
		sql.append(" where a.车辆型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid  or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid) or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		sql.append(" union all ");
		sql.append(" select a.企业ID as qyid, a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from RETRIEVAL.chpdpk_zk a ");
		sql.append(" where a.底盘型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid) or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		/*sql.append(" union all ");
		sql.append(" select a.企业ID as qyid, a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from NERDS.clcp_zk_new a ");
		sql.append(" where a.车辆型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and (a.企业ID =:qyid or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");
//			sql.append(" and a.企业ID =:qyid");
		}
		sql.append(" union all ");
		sql.append(" select a.企业ID as qyid, a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq from NERDS.chpdpk_zk_new a ");
		sql.append(" where a.底盘型号 =:xh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and (a.企业ID =:qyid or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");
//			sql.append(" and a.企业ID =:qyid");
		}*/
		sql.append(" ) z ");

		// 339 新增 start
//		sql.append(" WHERE (pc=339 and qyid=:qyid2) or (pc<>339 or pc is null) ");
//		sql.append(" WHERE (pc='"+pc+"' and (qyid=:qyid2 or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid) or qyid =(select group_username from RETRIEVAL.ret_users where username=:qyid2))) or (pc<>'"+pc+"' or pc is null)  ");
		sql.append(" WHERE (pc='"+pc+"' and (qyid=:qyid2  or qyid =(select group_username from RETRIEVAL.ret_users where username=:qyid2))) or (pc<>'"+pc+"' or pc is null)  ");
		// 339 新增 end
		sql.append(" order by to_number(z.pc) desc, z.cph ");
		Query query = entityManager.createNativeQuery(sql.toString());
		//query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		query.setParameter("xh", xh);
		if(qyid!=null && !"".equals(qyid)){
			query.setParameter("qyid", qyid);
		}

		query.setParameter("qyid2", qyid2);

		Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}

	/**
	 * 通过名称获取审核列表
	 * @param qyid
	 * @param cpmc 
	 * @param rlzl 
	 * @param cpsb 
	 * */
	@SuppressWarnings("unchecked")
	public List<Map<String, Object>> findnamePage339(PageParam page,String qymc, String qyid, String qyid2,String pc, String cpsb, String rlzl, String cpmc) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select t.* , rownum rn from (select * from ");
		sql.append(" ( ");
		sql.append(" select a.企业ID as qyid, a.中文品牌  as cppp,a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.clcp_zk a ");
		sql.append(" where 1=1 ");
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称 like :qymc");
		}
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid) or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");
		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(cpmc!=null && !"".equals(cpmc)){
			sql.append(" and a.车辆名称 like :cpmc");
		}
		sql.append(" union ");
		sql.append(" select a.企业ID as qyid, a.产品商标 as cppp,a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.chpdpk_zk a ");
		sql.append(" where 1=1 ");
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称 like :qymc");
		}
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid) or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}

		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(cpmc!=null && !"".equals(cpmc)){
			sql.append(" and a.产品名称 like :cpmc");
		}
		/*sql.append(" union ");
		sql.append(" select a.企业ID as qyid, a.中文品牌  as cppp,a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.clcp_zk_new  a ");
		sql.append(" where a.企业名称 like :name ");
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		sql.append(" union ");
		sql.append(" select a.企业ID as qyid, a.产品商标 as cppp,a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.chpdpk_zk_new a ");
		sql.append(" where a.企业名称 like :name ");
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}*/
		sql.append(" ) z ");

		// 339 新增 start
//		sql.append(" WHERE (pc=339 and qyid=:qyid2) or (pc<>339 or pc is null)  ");
		sql.append(" WHERE (pc='"+pc+"' and (qyid=:qyid2 or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid) or qyid =(select group_username from RETRIEVAL.ret_users where username=:qyid2))) or (pc<>'"+pc+"' or pc is null)  ");

		// 339 新增 end

		sql.append(" order by to_number(z.pc) desc, z.cph) t ");
		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);

        if(qymc!=null && !"".equals(qymc)){			 
        	query.setParameter("qymc", "%"+qymc+"%"); 
		}
		if(qyid!=null && !"".equals(qyid)){
			query.setParameter("qyid", qyid);
		}
		query.setParameter("qyid2", qyid2);

        if(pc!=null && !"".equals(pc)){
            query.setParameter("pc", pc);
        }
        if(cpsb!=null && !"".equals(cpsb)){
			query.setParameter("cpsb", cpsb);
		}
        if(rlzl!=null && !"".equals(rlzl)){
			query.setParameter("rlzl", rlzl);
		}
        if(cpmc!=null && !"".equals(cpmc)){
			query.setParameter("cpmc",  "%"+cpmc+"%");
		}
		query.setFirstResult(page.getOffset());
		query.setMaxResults(page.getLimit());
		List<Map<String, Object>> list = query.getResultList();
		return list;
	}
	public Long findnamePageCount339(String qymc, String qyid, String qyid2, String pc, String cpsb, String rlzl, String cpmc) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select count(*) from ");
		sql.append(" ( ");
		sql.append(" select a.企业ID as qyid, a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.clcp_zk a ");
		sql.append(" where 1=1 ");
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称 like :qymc");
		}
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid) or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.中文品牌 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(cpmc!=null && !"".equals(cpmc)){
			sql.append(" and a.车辆名称 like :cpmc");
		}
		sql.append(" union ");
		sql.append(" select a.企业ID as qyid, a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from RETRIEVAL.chpdpk_zk a ");
		sql.append(" where 1=1 ");
		if(qymc!=null && !"".equals(qymc)){
			sql.append(" and a.企业名称 like :qymc");
		}
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid) or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		if(pc!=null && !"".equals(pc)){
			sql.append(" and a.批次 =:pc");
		}
		if(cpsb!=null && !"".equals(cpsb)){
			sql.append(" and a.产品商标 =:cpsb");
		}
		if(rlzl!=null && !"".equals(rlzl)){
			sql.append(" and a.燃料种类 =:rlzl");
		}
		if(cpmc!=null && !"".equals(cpmc)){
			sql.append(" and a.产品名称 like :cpmc");
		}
		/*sql.append(" union ");
		sql.append(" select a.企业ID as qyid, a.产品号 as cph, a.cpno, a.中文品牌 as clpp1, a.车辆名称 as clmc, a.车辆型号 as clxh, a.企业名称 as qymc, a.批次 as pc, 1 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.clcp_zk_new a ");
		sql.append(" where a.企业名称 like :name ");
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}
		sql.append(" union ");
		sql.append(" select a.企业ID as qyid, a.产品号 as cph, a.dpid, a.产品商标 as clpp1, a.产品名称 as clmc, a.底盘型号 as clxh, a.企业名称 as qymc , a.批次 as pc, 2 as type, substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as ggsxrq ");
		sql.append(" from NERDS.chpdpk_zk_new a ");
		sql.append(" where a.企业名称 like :name ");
		if(qyid!=null && !"".equals(qyid)){
//			sql.append(" and a.企业ID =:qyid");
			sql.append(" and (a.企业ID =:qyid or a.企业ID =(select group_username from RETRIEVAL.ret_users where username=:qyid))");

		}*/
		sql.append(" ) z ");

		// 339 新增 start
//		sql.append(" WHERE (pc=339 and qyid=:qyid2) or (pc<>339 or pc is null)  ");
		sql.append(" WHERE (pc='"+pc+"' and (qyid=:qyid2 or a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid) or qyid =(select group_username from RETRIEVAL.ret_users where username=:qyid2))) or (pc<>'"+pc+"' or pc is null)  ");

		// 339 新增 end

		sql.append(" order by to_number(z.pc) desc, z.cph ");
		Query query = entityManager.createNativeQuery(sql.toString());
		//query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		sql.append(" where 1=1 ");
		if(qymc!=null && !"".equals(qymc)){ 
			query.setParameter("qymc", "%"+qymc+"%");
		}
		if(qyid!=null && !"".equals(qyid)){
			query.setParameter("qyid", qyid);
		}
		query.setParameter("qyid2", qyid2);

        if(pc!=null && !"".equals(pc)){
            query.setParameter("pc", pc);
        }
        if(cpsb!=null && !"".equals(cpsb)){
			query.setParameter("cpsb", cpsb);
		}
        if(rlzl!=null && !"".equals(rlzl)){
			query.setParameter("rlzl", rlzl);
		}
        if(cpmc!=null && !"".equals(cpmc)){
			query.setParameter("cpmc",  "%"+cpmc+"%");
		}
		Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}
	public List<Map<String, Object>> findMoreList339(PageParam page,SearchProductParams spp,String qyid,String pc) {

		StringBuffer bf = new StringBuffer();

		Object[] params = null;
		final List<Map<String, String>> productLs = new ArrayList<Map<String, String>>();

		Map<String, Object[]> m = this.getSqlAndParams339(spp);
		bf.append(" select t.* , rownum rn from ( ");
		bf.append("select 企业ID, 企业名称,产品号,产品商标,批次,产品型号,产品名称,生产地址,轴数,轴距,总质量,轮胎规格,M发动机,前轮距,后轮距,燃料种类,发布日期,substr(a.生效日期, 1, 4)||'-'||substr(a.生效日期, 5, 2)||'-'||substr(a.生效日期, 7, 2) as 生效日期 ,type,rownum rm from (");

		bf.append(m.keySet().toArray()[0]);
		params = (Object[]) m.values().toArray()[0];

		bf.append(" ) order by 企业名称,批次  desc ) a ");

		bf.append(" WHERE (批次='"+pc+"' and 企业ID=:qyid) or (批次='"+pc+"' and a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid)) or (批次='"+pc+"' and 企业ID=(select group_username from RETRIEVAL.ret_users where username=:qyid))  or (批次<>'"+pc+"' or 批次 is null)  ");

		bf.append(" ) t");

		System.out.println("findMoreList339:"+bf.toString());
		Query query = entityManager.createNativeQuery(bf.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		for(int i=1 ;i<=params.length;i++){


			query.setParameter(i, params[i-1]);
		}
		query.setParameter("qyid", qyid);

		query.setFirstResult(page.getOffset());
		query.setMaxResults(page.getLimit());
		List<Map<String, Object>> list = query.getResultList();
		return list;
	}


	/**
	 * 获取高级查询结果的总数量
	 *
	 * @param spp
	 * @return
	 */
	public Long findMorePageCount339(SearchProductParams spp, String qyid,String pc) {
		StringBuffer bf = new StringBuffer();
		bf.append("select count(产品号) from ( ");
		Map<String, Object[]> m = this.getSqlAndParams339(spp);

		bf.append(m.keySet().toArray()[0]);
//		bf.append(")WHERE (批次=339 and 企业ID=:qyid) or (批次<>339 or 批次 is null))");
		bf.append(")WHERE (批次='"+pc+"'  and 企业ID=:qyid) or (批次='"+pc+"' and a.企业名称 =(select  name from RETRIEVAL.ret_users where username=:qyid))  or (批次='"+pc+"' and 企业ID=(select group_username from RETRIEVAL.ret_users where username=:qyid)) or (批次<>'"+pc+"' or 批次 is null))");

		Object[] params = (Object[]) m.values().toArray()[0];
		System.out.println("findMorePageCount339:"+bf.toString());
		Query query = entityManager.createNativeQuery(bf.toString());
		for(int i=1 ;i<=params.length;i++){
			query.setParameter(i, params[i-1]);
		}
		query.setParameter("qyid", qyid);
		Long count=Long.parseLong(query.getSingleResult().toString());
		return count;
	}

	/**
	 * 获取高级查询的sql和参数
	 *
	 * @param spp
	 * @return
	 */
	private Map<String, Object[]> getSqlAndParams339(SearchProductParams spp) {
		StringBuffer zcbf = new StringBuffer();
		StringBuffer dpbf = new StringBuffer();
		//新加
		StringBuffer zcbfAdd = new StringBuffer();

		List<Object> zcParamList = new ArrayList<Object>();
		List<Object> dpParamList = new ArrayList<Object>();
		//新加
		List<Object> zcParamListAdd = new ArrayList<Object>();

		StringBuffer bf = new StringBuffer();
		Object[] params = null;
		Map<String, Object[]> m = new HashMap<String, Object[]>();

		bf.append("select 企业ID,企业名称,产品号,产品商标,批次,产品型号,产品名称,生产地址,轴数,轴距,总质量,轮胎规格,M发动机,前轮距,后轮距,燃料种类,发布日期,生效日期,type  from (");
		zcbf.append("select 企业ID,企业名称,产品号,产品商标,批次,车辆型号 as 产品型号,车辆名称 as 产品名称,生产地址,轴数,轴距,总质量,轮胎规格,M发动机,前轮距,后轮距,燃料种类,发布日期,生效日期,1 as type  from retrieval.clcp_zk where 1=1 ");
		dpbf.append("select 企业ID,企业名称,产品号,产品商标,批次,底盘型号 as 产品型号,产品名称,生产地址,轴数,轴距,总质量,轮胎规格,M发动机,前轮距,后轮距,燃料种类,发布日期,生效日期,2 as type  from retrieval.chpdpk_zk  where 1=1 ");


		if (null != spp && spp.getQymc() != null && !"".equals(spp.getQymc())) {
			zcbf.append(" and 企业名称 like ?");
			zcParamList.add("%" + spp.getQymc().trim() + "%");

			dpbf.append(" and 企业名称 like ?");
			dpParamList.add("%" + spp.getQymc().trim() + "%");
		}

		if (null != spp && spp.getCph() != null && !"".equals(spp.getCph())) {
			zcbf.append(" and 产品号 like ?");
			zcParamList.add("%" + spp.getCph().trim() + "%");

			dpbf.append(" and 产品号 like ?");
			dpParamList.add("%" + spp.getCph().trim() + "%");
		}

		if (null != spp && spp.getCpsb() != null && !"".equals(spp.getCpsb())) {
			zcbf.append(" and 产品商标 like ?");
			zcParamList.add("%" + spp.getCpsb().trim() + "%");

			dpbf.append(" and 产品商标 like ?");
			dpParamList.add("%" + spp.getCpsb().trim() + "%");
		}

		//新加
		boolean flag = false;
		if (null != spp && spp.getCpsb() != null && !"".equals(spp.getCpsb())&& !"".equals(spp.getPfjd())&& spp.getPfjd() != null ) {

			//新加
			zcbfAdd.append("select 企业名称,产品号,产品商标,批次,车辆型号 as 产品型号,车辆名称 as 产品名称,生产地址,轴数,轴距,总质量,轮胎规格,M发动机,前轮距,后轮距,燃料种类,发布日期,生效日期,1 as type  from retrieval.clcp_zk where 1=1 ");

			zcbfAdd.append(" and 底盘ID1 IN ( SELECT dpid FROM retrieval.chpdpk_zk WHERE 依据标准 LIKE ? ) AND 产品商标 LIKE ? ");
			zcParamListAdd.add("%" + spp.getPfjd().trim() + "%");
			zcParamListAdd.add("%" + spp.getCpsb().trim() + "%");
			flag = true;
		}

		//新加 ======begin
		if (flag && null != spp && spp.getQymc() != null && !"".equals(spp.getQymc())) {
			zcbfAdd.append(" and 企业名称 like ?");
			zcParamListAdd.add("%" + spp.getQymc().trim() + "%");
		}

		if (flag && null != spp && spp.getCph() != null && !"".equals(spp.getCph())) {
			zcbfAdd.append(" and 产品号 like ?");
			zcParamListAdd.add("%" + spp.getCph().trim() + "%");
		}
		//新加 ======end

		if (null != spp && spp.getPc() != null && !"".equals(spp.getPc())) {
			zcbf.append(" and 批次 = ?");
			zcParamList.add(spp.getPc());

			dpbf.append(" and 批次 = ?");
			dpParamList.add(spp.getPc());
		}

		//新增
		if (flag && null != spp && spp.getPc() != null && !"".equals(spp.getPc())) {
			zcbfAdd.append(" and 批次 = ?");
			zcParamListAdd.add(spp.getPc());
		}


//		if (null != spp && spp.getPfjd() != null && !"".equals(spp.getPfjd())) {
//			zcbf.append(" and 排放水平 = ?");
//			zcParamList.add(spp.getPfjd());
//
//			dpbf.append(" and 排放水平 = ?");
//			dpParamList.add(spp.getPfjd());
//		}

		if (null != spp && spp.getPfjd() != null && !"".equals(spp.getPfjd())) {
			zcbf.append(" and 依据标准 like ?");
			zcParamList.add("%" + spp.getPfjd().trim() + "%");
			dpbf.append(" and 依据标准 like ?");
			dpParamList.add("%" + spp.getPfjd().trim() + "%");
		}


		if (null != spp && spp.getDpxh() != null && !"".equals(spp.getDpxh())) {
			zcbf.append(" and 底企型1 like ?");
			zcParamList.add("%" + spp.getDpxh().trim() + "%");
			dpbf.append(" and 底盘型号 like ?");
			dpParamList.add("%" + spp.getDpxh().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getDpxh() != null && !"".equals(spp.getDpxh())) {
			zcbfAdd.append(" and 底企型1 like ?");
			zcParamListAdd.add("%" + spp.getDpxh().trim() + "%");
		}

		if (null != spp && spp.getCpxh() != null && !"".equals(spp.getCpxh())) {
			zcbf.append(" and 车辆型号 like ?");
			zcParamList.add("%" + spp.getCpxh().trim() + "%");

			dpbf.append(" and 底盘型号 like ?");
			dpParamList.add("%" + spp.getCpxh().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getCpxh() != null && !"".equals(spp.getCpxh())) {
			zcbfAdd.append(" and 车辆型号 like ?");
			zcParamListAdd.add("%" + spp.getCpxh().trim() + "%");
		}

		if (null != spp && spp.getCpmc() != null && !"".equals(spp.getCpmc())) {
			zcbf.append(" and 车辆名称 like ?");
			zcParamList.add("%" + spp.getCpmc().trim() + "%");

			dpbf.append(" and 产品名称 like ?");
			dpParamList.add("%" + spp.getCpmc().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getCpmc() != null && !"".equals(spp.getCpmc())) {
			zcbfAdd.append(" and 车辆名称 like ?");
			zcParamListAdd.add("%" + spp.getCpmc().trim() + "%");
		}


		if (null != spp && spp.getScdz() != null && !"".equals(spp.getScdz())) {
			zcbf.append(" and 生产地址 like ?");
			zcParamList.add("%" + spp.getScdz().trim() + "%");

			dpbf.append(" and 生产地址 like ?");
			dpParamList.add("%" + spp.getScdz().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getScdz() != null && !"".equals(spp.getScdz())) {
			zcbfAdd.append(" and 生产地址 like ?");
			zcParamListAdd.add("%" + spp.getScdz().trim() + "%");
		}



		if (null != spp && spp.getZs() != null && !"".equals(spp.getZs())) {
			zcbf.append(" and 轴数 like ?");
			zcParamList.add("%" + spp.getZs().trim() + "%");

			dpbf.append(" and 轴数 like ?");
			dpParamList.add("%" + spp.getZs().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getZs() != null && !"".equals(spp.getZs())) {
			zcbfAdd.append(" and 轴数 like ?");
			zcParamListAdd.add("%" + spp.getZs().trim() + "%");
		}


		if (null != spp && spp.getZj() != null && !"".equals(spp.getZj())) {
			zcbf.append(" and 轴距 like ?");
			zcParamList.add("%" + spp.getZj().trim() + "%");

			dpbf.append(" and 轴距 like ?");
			dpParamList.add("%" + spp.getZj().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getZj() != null && !"".equals(spp.getZj())) {
			zcbfAdd.append(" and 轴距 like ?");
			zcParamListAdd.add("%" + spp.getZj().trim() + "%");
		}


		if (null != spp && spp.getLts() != null && !"".equals(spp.getLts())) {
			zcbf.append(" and 轮胎数 like ?");
			zcParamList.add("%" + spp.getLts().trim() + "%");

			dpbf.append(" and 轮胎数 like ?");
			dpParamList.add("%" + spp.getLts().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getLts() != null && !"".equals(spp.getLts())) {
			zcbfAdd.append(" and 轮胎数 like ?");
			zcParamListAdd.add("%" + spp.getLts().trim() + "%");
		}


		if (null != spp && spp.getFdjxh() != null && !"".equals(spp.getFdjxh())) {
			zcbf.append(" and M发动机 like ?");
			zcParamList.add("%" + spp.getFdjxh().trim() + "%");

			dpbf.append(" and M发动机 like ?");
			dpParamList.add("%" + spp.getFdjxh().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getFdjxh() != null && !"".equals(spp.getFdjxh())) {
			zcbfAdd.append(" and M发动机 like ?");
			zcParamListAdd.add("%" + spp.getFdjxh().trim() + "%");
		}

		if (null != spp && spp.getQlj() != null && !"".equals(spp.getQlj())) {
			zcbf.append(" and 前轮距 like ?");
			zcParamList.add("%" + spp.getQlj().trim() + "%");

			dpbf.append(" and 前轮距 like ?");
			dpParamList.add("%" + spp.getQlj().trim() + "%");
		}

		//新增
		if (flag && null != spp && spp.getQlj() != null && !"".equals(spp.getQlj())) {
			zcbfAdd.append(" and 前轮距 like ?");
			zcParamListAdd.add("%" + spp.getQlj().trim() + "%");
		}


		if (null != spp && spp.getHlj() != null && !"".equals(spp.getHlj())) {
			zcbf.append(" and 后轮距 like ?");
			zcParamList.add("%" + spp.getHlj().trim() + "%");

			dpbf.append(" and 后轮距 like ?");
			dpParamList.add("%" + spp.getHlj().trim() + "%");
		}

		//新加
		if (flag && null != spp && spp.getHlj() != null && !"".equals(spp.getHlj())) {
			zcbfAdd.append(" and 后轮距 like ?");
			zcParamListAdd.add("%" + spp.getHlj().trim() + "%");
		}


		if (null != spp && spp.getRlzl() != null && !"".equals(spp.getRlzl())) {
			zcbf.append(" and 燃料种类 like ?");
			zcParamList.add("%" + spp.getRlzl().trim() + "%");

			dpbf.append(" and 燃料种类 like ?");
			dpParamList.add("%" + spp.getRlzl().trim() + "%");
		}

		//新加
		if (flag && null != spp && spp.getRlzl() != null && !"".equals(spp.getRlzl())) {
			zcbfAdd.append(" and 燃料种类 like ?");
			zcParamListAdd.add("%" + spp.getRlzl().trim() + "%");
		}

		// 长前
		if (null != spp && spp.getWxchangq() != null && !"".equals(spp.getWxchangq())) {
			zcbf.append(" and chang_n >= ?");
			zcParamList.add(spp.getWxchangq());

			dpbf.append(" and chang_n >= ?");
			dpParamList.add(spp.getWxchangq());
		}

		//新加     长前
		if (flag && null != spp && spp.getWxchangq() != null && !"".equals(spp.getWxchangq())) {
			zcbfAdd.append(" and chang_n >= ?");
			zcParamListAdd.add(spp.getWxchangq());
		}


		// 长后
		if (null != spp && spp.getWxchangh() != null && !"".equals(spp.getWxchangh())) {
			zcbf.append(" and chang_n <= ?");
			zcParamList.add(spp.getWxchangh());

			dpbf.append(" and chang_n <= ?");
			dpParamList.add(spp.getWxchangh());
		}

		// 新加  长后
		if (flag && null != spp && spp.getWxchangh() != null && !"".equals(spp.getWxchangh())) {
			zcbfAdd.append(" and chang_n <= ?");
			zcParamListAdd.add(spp.getWxchangh());
		}


		// 宽前
		if (null != spp && spp.getWxkuanq() != null && !"".equals(spp.getWxkuanq())) {
			zcbf.append(" and kuan_n >= ?");
			zcParamList.add(spp.getWxkuanq());

			dpbf.append(" and kuan_n >= ?");
			dpParamList.add(spp.getWxkuanq());
		}


		// 新加   宽前
		if (flag && null != spp && spp.getWxkuanq() != null && !"".equals(spp.getWxkuanq())) {
			zcbfAdd.append(" and kuan_n >= ?");
			zcParamListAdd.add(spp.getWxkuanq());
		}


		// 宽后
		if (null != spp && spp.getWxkuanh() != null && !"".equals(spp.getWxkuanh())) {
			zcbf.append(" and kuan_n <= ?");
			zcParamList.add(spp.getWxkuanh());

			dpbf.append(" and kuan_n <= ?");
			dpParamList.add(spp.getWxkuanh());
		}


		//新加  宽后
		if (flag && null != spp && spp.getWxkuanh() != null && !"".equals(spp.getWxkuanh())) {
			zcbfAdd.append(" and kuan_n <= ?");
			zcParamListAdd.add(spp.getWxkuanh());
		}


		// 高前
		if (null != spp && spp.getWxgaoq() != null && !"".equals(spp.getWxgaoq())) {
			zcbf.append(" and gao_n >= ?");
			zcParamList.add(spp.getWxgaoq());

			dpbf.append(" and gao_n >= ?");
			dpParamList.add(spp.getWxgaoq());
		}


		// 新加  高前
		if (flag && null != spp && spp.getWxgaoq() != null && !"".equals(spp.getWxgaoq())) {
			zcbfAdd.append(" and gao_n >= ?");
			zcParamListAdd.add(spp.getWxgaoq());
		}


		// 高后
		if (null != spp && spp.getWxgaoh() != null && !"".equals(spp.getWxgaoh())) {
			zcbf.append(" and gao_n <= ?");
			zcParamList.add(spp.getWxgaoh());

			dpbf.append(" and gao_n <= ?");
			dpParamList.add(spp.getWxgaoh());
		}

		//新加    高后
		if (flag && null != spp && spp.getWxgaoh() != null && !"".equals(spp.getWxgaoh())) {
			zcbfAdd.append(" and gao_n <= ?");
			zcParamListAdd.add(spp.getWxgaoh());
		}



		// 总质量前
		if (null != spp && spp.getZzlq() != null && !"".equals(spp.getZzlq())) {
			//zcbf.append(" and zzl_n >= ?");
			zcbf.append(" and 总质量 >= ?");

			zcParamList.add(spp.getZzlq());

			//dpbf.append(" and zzl_n >= ?");
			dpbf.append(" and 总质量 >= ?");

			dpParamList.add(spp.getZzlq());
		}


		// 新加 总质量前
		if (flag  && null != spp && spp.getZzlq() != null && !"".equals(spp.getZzlq())) {
			zcbfAdd.append(" and 总质量 >= ?");
			zcParamListAdd.add(spp.getZzlq());
		}


		// 总质量后
		if (null != spp && spp.getZzlh() != null && !"".equals(spp.getZzlh())) {
//			zcbf.append(" and zzl_n <= ?");
			zcbf.append(" and 总质量 <= ?");
			zcParamList.add(spp.getZzlh());

//			dpbf.append(" and zzl_n <= ?");
			dpbf.append(" and 总质量 <= ?");

			dpParamList.add(spp.getZzlh());
		}

		// 新增  总质量后
		if (flag && null != spp && spp.getZzlh() != null && !"".equals(spp.getZzlh())) {
			zcbfAdd.append(" and 总质量 <= ?");
			zcParamListAdd.add(spp.getZzlh());
		}




		// 额定质量前
		if (null != spp && spp.getEdzlq() != null && !"".equals(spp.getEdzlq())) {
			zcbf.append(" and edzl_n >= ?");
			zcParamList.add(spp.getEdzlq());

			dpbf.append(" and edzl_n >= ?");
			dpParamList.add(spp.getEdzlq());
		}

		// 新增  额定质量前
		if (flag && null != spp && spp.getEdzlq() != null && !"".equals(spp.getEdzlq())) {
			zcbfAdd.append(" and edzl_n >= ?");
			zcParamListAdd.add(spp.getEdzlq());
		}



		// 额定质量后
		if (null != spp && spp.getEdzlh() != null && !"".equals(spp.getEdzlh())) {
			zcbf.append(" and zzl_n <= ?");
			zcParamList.add(spp.getEdzlh());

			dpbf.append(" and zzl_n <= ?");
			dpParamList.add(spp.getEdzlh());
		}


		//新增  额定质量后
		if (flag && null != spp && spp.getEdzlh() != null && !"".equals(spp.getEdzlh())) {
			zcbfAdd.append(" and zzl_n <= ?");
			zcParamListAdd.add(spp.getEdzlh());
		}


		// 整备质量前
		if (null != spp && spp.getZbzlq() != null && !"".equals(spp.getZbzlq())) {
			zcbf.append(" and zbzl_n >= ?");
			zcParamList.add(spp.getZbzlq());

			dpbf.append(" and zbzl_n >= ?");
			dpParamList.add(spp.getZbzlq());
		}


		//新增   整备质量前
		if (flag && null != spp && spp.getZbzlq() != null && !"".equals(spp.getZbzlq())) {
			zcbfAdd.append(" and zbzl_n >= ?");
			zcParamListAdd.add(spp.getZbzlq());
		}

		// 整备质量后
		if (null != spp && spp.getZbzlh() != null && !"".equals(spp.getZbzlh())) {
			zcbf.append(" and zbzl_n <= ?");
			zcParamList.add(spp.getZbzlh());

			dpbf.append(" and zbzl_n <= ?");
			dpParamList.add(spp.getZbzlh());
		}

		// 新增  整备质量后
		if (flag && null != spp && spp.getZbzlh() != null && !"".equals(spp.getZbzlh())) {
			zcbfAdd.append(" and zbzl_n <= ?");
			zcParamListAdd.add(spp.getZbzlh());
		}


		if ((null != spp && spp.getChang() != null && !"".equals(spp.getChang())) || (null != spp && spp.getKuan() != null && !"".equals(spp.getKuan())) || (null != spp && spp.getGao() != null && !"".equals(spp.getGao()))) {

			zcbf.append("and 货厢长 like ? ");
			zcbf.append("and 货厢宽 like ? ");
			zcbf.append("and 货厢高 like ? ");

			zcParamList.add("%" + spp.getChang().trim() + "%");
			zcParamList.add("%" + spp.getKuan().trim() + "%");
			zcParamList.add("%" + spp.getGao().trim() + "%");

			bf.append(zcbf);
			params = zcParamList.toArray();
		} else {
			bf.append(zcbf);
			bf.append(" union all ");
			bf.append(dpbf);
			//新加
			if(flag){
				bf.append(" union all ");
				bf.append(zcbfAdd);
			}
			zcParamList.addAll(dpParamList);
			//新加
			if(flag){
				zcParamList.addAll(zcParamListAdd);
			}
			params = zcParamList.toArray();

		}

		m.put(bf.toString(), params);

		return m;
	}


	/**   
	 * @Title: findGroup   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qyid
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @date 下午3:49:05 
	*/   
	public String findGroup(String qyid) {
		String sql = "select GROUP_USERNAME from RETRIEVAL.ret_users where username= ?";
		Query query = entityManager.createNativeQuery(sql.toString());
		query.setParameter(1,qyid);
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		String RESULT=list.get(0).get("GROUP_USERNAME")==null?"":list.get(0).get("GROUP_USERNAME").toString();
		return RESULT;
	}


	/**   
	 * @Title: findPc   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param string
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午6:37:27 
	*/   
	public List<Map<String, Object>> findPc(String qyid) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select distinct  批次 pc");
		sql.append(" from RETRIEVAL.clcp_zk   ");//车辆产品总库
		sql.append(" where 批次 is not null ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and 企业ID =:qyid");
		}
		sql.append(" order by to_number(批次) desc ");
		 
		Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        if(qyid!=null && !"".equals(qyid)){
            query.setParameter("qyid", qyid);
        }
		List<Map<String, Object>> list = query.getResultList();
		return list; 
	}


	/**   
	 * @Title: findCpmcByCpxh   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param cpxh
	 * @param @param pc
	 * @param @param qyid
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午1:18:24 
	*/   
	public List<Map<String, Object>> findCpmcByCpxh(String cpxh, String pc,
			String qyid) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select DISTINCT 车辆名称 as CPMC  from RETRIEVAL.clcp_zk "); 
		sql.append(" WHERE  车辆型号= :cpxh ");
		if(qyid!=null && !"".equals(qyid)){
			sql.append(" and 企业ID =:qyid");
		} 
		if(pc!=null && !"".equals(pc)){
			sql.append(" and to_number(批次) =:pc");
		} 
		Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setParameter("cpxh", cpxh);
        if(qyid!=null && !"".equals(qyid)){
            query.setParameter("qyid", qyid);
        } 
		if(pc!=null && !"".equals(pc)){
			query.setParameter("pc", pc);
		}
		List<Map<String, Object>> list = query.getResultList();
		return list; 
	}

	public String findPcInfo() {
		String sql = "select pc from nerds.CHECKFLAG ";
		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		String RESULT=list.get(0).get("PC")==null?"":list.get(0).get("PC").toString();
		return RESULT;
	}

	public String findLoginFlagInfo() {
		String sql = "select LOGINFLAG from nerds.CHECKFLAG ";
		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		String RESULT=list.get(0).get("LOGINFLAG")==null?"":list.get(0).get("LOGINFLAG").toString();
		return RESULT;
	}	
	
}
