package com.adc.da.bs.reportManage.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 文件上传入参VO
 *
 * @author Deng
 * @version V1.0
 * @date 2020-03-20 16:12
 **/
@ApiModel(value = "ReportUploadVO",description = "报告上传基本信息")
public class ReportUploadVO {

    /**
     * 报告编号
     */
    @ApiModelProperty(value = "报告编号")
    private String bgbh;

    /**
     * 产品型号
     */
    @ApiModelProperty(value = "产品型号")
    private String cpxh;

    /**
     * 产品名称
     */
    @ApiModelProperty(value = "产品名称")
    private String cpmc;

    /**
     * 产品商标
     */
    @ApiModelProperty(value = "产品商标")
    private String cpsb;

    /**
     * 项目名称
     */
    @ApiModelProperty(value = "项目名称")
    private String xmmc;

    /**
     * 报告类型
     */
    @ApiModelProperty(value = "报告类型 整车报告:ZCBG ; 零部件报告: LBJBG")
    private String reportType;

    /**
     * 企业ID
     */
    @ApiModelProperty(value = "企业ID")
    private String qyid;

    /**
     * 企业名称
     */
    @ApiModelProperty(value = "企业名称")
    private String qymc;

    public String getBgbh() {
        return bgbh;
    }

    public void setBgbh(String bgbh) {
        this.bgbh = bgbh;
    }

    public String getCpmc() {
        return cpmc;
    }

    public void setCpmc(String cpmc) {
        this.cpmc = cpmc;
    }

    public String getCpxh() {
        return cpxh;
    }

    public void setCpxh(String cpxh) {
        this.cpxh = cpxh;
    }

    public String getCpsb() {
        return cpsb;
    }

    public void setCpsb(String cpsb) {
        this.cpsb = cpsb;
    }

    public String getXmmc() {
        return xmmc;
    }

    public void setXmmc(String xmmc) {
        this.xmmc = xmmc;
    }

    public String getReportType() {
        return reportType;
    }

    public void setReportType(String reportType) {
        this.reportType = reportType;
    }

    public String getQyid() {
        return qyid;
    }

    public void setQyid(String qyid) {
        this.qyid = qyid;
    }

    public String getQymc() {
        return qymc;
    }

    public void setQymc(String qymc) {
        this.qymc = qymc;
    }
}
